-- Author      : Phil Lawson
-- Create Date : 14/4/2014
-- Abigail 2.40 addon
-- Works with 5.40 and Auctionator 3.1.5

-- This addon may be freely distributed. It may not be distributed for profit, and it must declare the author to be Phil Lawson.

-- No addon libraries used.
-- Massive thanks to J.Whitehead II for the help given through wowprogramming.com, the website that accompanies the World of Warcraft Programming books.


-- NEW abivariable list since 1.30
-- time,minspend,maxspend,profit,cashprofit,deviation
-- TooltipCB1,TooltipCB2,TooltipCB3,TooltipCB4,TooltipCB5,TooltipCB6
-- 11 item classes
-- [24] is used to store the stacksize for tooltips
-- [25] is used to store the Max Same slider value

-- Since 2.30 - [26] Show Recent Hi/Low values
-- Since 2.30 - [27] Auto Open/Close bags on leaving Selling Screen

-- Since 2.20 - Earned and Spent values now in abiPLV [RealmFaction][1]earned and [RealmFaction][2]spent

-- Changed in 2.10
-- abiVariables not used
-- Now uses abiPresets[1-6][1-32]
-- [1-6] is the saved presets
-- [1-27] is the standard variable values as above
-- [28] is the description name of the preset set.
-- [29] is the scantype (full getall or slow scan)
-- [30] is buyout/bid type
-- [31] is Current or Full Price History
-- [32] holds the current version number

-- Added in 2.15
-- abiLastZero is the time in seconds when the last Max Deviation at zero scan was done

-- Added in 2.20
-- abiTimeStamp field added to the PriceIndex file.
-- *****************************************************

-- after every blizzard update and/or auctionator update, must check that the following variables, labels, sub.strings still work accurately.
-- Blizzards Texts - GOLD_AMOUNT_TEXTURE, SILVER_AMOUNT_TEXTURE, COPPER_AMOUNT_TEXTURE, LAST_ITEM_BUYOUT, LAST_ITEM_AUCTIONED, LAST_ITEM_START_BID

-- From Blizzards own code - BrowseName:SetText, MoneyInputFrame_SetCopper(BuyoutPrice, abiShigh1), MoneyInputFrame_SetCopper(StartPrice, abiShigh1)

-- From Auctionator - Atr_Search_Box:SetText, gFullScanStart = time(), gFullScanDur = nil

-- Functions hooked - GameTooltip:"OnTooltipSetItem", GameTooltip:"OnTooltipCleared", GameTooltip:"SetBagItem",GameTooltip:"SetInventoryItem"

-- AuctionFrameTab_OnClick:abiFrameTab_OnClick
-- Atr_FullScanDone:HookScript("OnClick",abiAuctionatorScanned)
-- Atr_FullScanStartButton:HookScript("OnClick",abiAuctionatorStarted)

-- Make sure the classes list is the same (Use GetAuctionItemClasses()) to see full list.

-- *****************************************************

-- TO DO Colour-code the buyout prices on the selling screen
-- Done 1/5/14

-- TO DO Make sure the Adjust Screen has all its buttons reset when leaving the screen
-- Done 18/6/14

-- TO DO Check bug on Shopping Screen, when undercut auctions have been cancelled, this screen may produce an error thinking another cancel is required.

-- TO DO Check the Delete Screen is not deleting items in the Shopping List.
-- Needs to be further tested, as it went wrong after a delete, then a Shopping List search.

-- Also make sure that when returning to Shopping screen, the Generate function is called to re-populate the items available to be added,
-- so that any items deleted are not still present in this list.
-- Instead, remove the Generate button, and make the Shopping screen automatically populate the items available to be added.
-- Done 7/7/14

-- If the auto-generate finds no items, put the message No Items Available on the first line of generate screen.
-- Done 7/7/14
-- Needs to display this message if all the items have been added to the shopping list.

-- TO DO Include in the Self Clean routines, remove from shopping list ay items not in the price index file.
-- Done 1/7/14 - to be checked

-- TO DO Put in an option to search (on main screen) for only those items that only appear once.
-- Done 19/6/14

-- TO DO when Show Best 5 is on, adjust the help message at bottom of screen
-- Done 18/6/14

-- TO DO Fixed a bug that occurred when sometimes mousing over Tiller items.
-- Done 10/6/14

-- TO DO Fixed a bug that sometimes occurred when summoning a mount.
-- Done 14/6/14

-- TO DO Need to fix a bug when shift-clicking on items from the Mailbox.
-- Seems ok now

-- TO DO Change the Slots Needed messages on the Mailbox screen to Items To Take
-- Done 15/7/14

-- TO DO Make sure the tooltip shows full details, even when the Current Prices option is set.
-- Done 16/7/14 - to be checked

local abiFirstRun=0
local abiShowingFive=1 -- 1=Turned off, 2=Turned on
local abiScanType=1 -- 1=Full Getall, 2=Slow Page-by-Page, 3=Unlimited Scan
local abitotalpages=0
local abiScanSlowPage=0
local abiDoingASlowScan=0
local abiLastSlowPage=9999 -- just make sure its different from abiScanSlowPage so the first page can be read.
local abiBestFiveButtonPressed=0
local abiStackSize
local abiBidTime=0
local abiMAX_ALLOWED_AUCTIONS=42554
local abiAuctionatorScanStarted=0
local abiSetForLookingAtNextPage=0
local abiBuyThisItem
local abiBuyThisPrice
local abiHowSorted=0
local abiDoingABuyout=0
local abiPopupShown=0
local abiSearchingWhichPage=0
local abiOptionsTabNum
local abiBargainsTabNum
local abiShoppingTabNum
local abiSellingTabNum
local abiAdjustingTabNum
local abiTableOffset=0
local abiname,abicount,abibuyoutPrice,abiminBid,abiminIncrement,abibidAmount
local abiImageName,abiImageCount,abiImagePrice,abiItemLink,abiImageTime,abiImageBid
local abiLink1,abiBhigh1,abiBlow1,abiShigh1,abiSlow1,abiRsold1,abiRbought1,abiRatio1,abiSeen1,abiTempTime,abiRecentHigh,abiRecentLow,abiPriceHistory

local abiImageNumber,abiIndexNumber
local abiHowManyAuctions
local abiAreWeReadingTheAH=0
local abiCanTakeSnapShot=0
local abiTooltipAdded=false
local abiBuyoutFound=0
local abiMyAuctionPlaced=0
local abiOnTheButton=0
local abiSortingByPercent=0
local abiAuctionHouseShown=0
local abiDisplayingFiveAuctions=0
local abiDisplayFivePage=0
local abiLastScreen=0

local abiBuying={}
local abiFiveAuctions={}
local abiDHpos={15,52,325,455,580}
local abiDHwide={60,100,120,120,150}
local abiDHtext={"Dur","Item Name","Buyout Value","Bid Value","Buyout per Unit"}

function abiHomeScreenFrame_OnLoad()
	abiStackUnitPrices=0
	abiTimeStamp=time()
	abiNilLink="|cff9d9d9d|Hitem:0000:0:0:0:0:0:0:0:80:0:0|h[Nil Item]|h|r"
	abiLastSearchText="No Search Done Yet"
	abiLastSearch="Bargains"
	abiLastByBuyout=0
	abiWhichPreset=1
	abiMyFaction,_=UnitFactionGroup("Player")
	abiTempName=""
	abiTesting=0
	abiCurrent=0
	abiAHImage={}
	abiBargains={}
	abiSB={}
	abiCurrentAuctions={}
	abiMyAuctions={}
	abiHistoryCost={}
	abiHistorySeen={}
	abiMyTempAuctions={}
	abiMyBids={}
	abiMyTempBids={}
	abiOptionsHelpText={}
	abiBargainsHelpText={}
	abiTabText={}

	abiOptionsHelpText[1]="A Snapshot is required"
	abiOptionsHelpText[2]="Reading Auction House - may take 10-90 seconds"
	abiOptionsHelpText[3]="Search for Bargains, Bids or Undercuts"

	abiBargainsHelpText[1]="The Bargains Screen - Buy items or Edit Price History"
	abiBargainsHelpText[2]="All prices on this screen are 'per unit' prices"
	abiBargainsHelpText[4]="Toggles History prices by Stack Size"
	abiBargainsHelpText[5]="L-Click = Copy Name, R-Click = Force, Shift R-Click = - Price"
	abiBargainsHelpText[6]="L-Click = Buy Item,  R-Click = Toggle Stack"
	abiBargainsHelpText[7]="L-Click = Bid on Item, R-Click = Toggle Stack"
	abiBargainsHelpText[8]="L-Click item name to show best 5 current auctions"

	abiTypeTable={"Weapon","Armor","Container","Consumable","Glyph","Trade Goods","Recipe","Gem","Miscellaneous","Quest","Battle Pets"}
	abiBidTimeTable={"Bids Under 30 Mins","Bids Under 2 Hrs","Bids Under 12 hrs","All Bids","Undercuts","My Profits","Single Items","Buyouts"}
	abiDisplayDurTable={"S","M","L","V"}
	abiFullDurTable={"Short","Medium","Long","Very Long"}
	abiScanTypeText={"Quick Get All Scan","Page-by-Page Scan","Unlimited Scan"}
	abiHomeScreenFrame:Hide()

	abiHowManyBargains=0

	DoTheRegistering()
	GameTooltip:HookScript("OnTooltipSetItem",abiTooltipSetItem)
	GameTooltip:HookScript("OnTooltipCleared",abiTooltipCleared)
	abiRealm=GetRealmName()..abiMyFaction
	
	if abiPresets==nil then
		abiPresets={}
		abiPresets[1]={}
		abiPresets[2]={}
		abiPresets[3]={}
		abiPresets[4]={}
		abiPresets[5]={}
		abiPresets[6]={}

		for abiloop=1,27 do
			abiPresets[1][abiloop]=0
			abiPresets[2][abiloop]=0
			abiPresets[3][abiloop]=0
			abiPresets[4][abiloop]=0
			abiPresets[5][abiloop]=0
			abiPresets[6][abiloop]=0
		end

		abiPresets[1][28]="Standard Settings"
		abiPresets[2][28]="Unused"
		abiPresets[3][28]="Unused"
		abiPresets[4][28]="Unused"
		abiPresets[5][28]="Unused"
		abiPresets[6][28]="Unused"

		for abiloop=1,6 do
			abiPresets[abiloop][29]=1
			abiPresets[abiloop][30]=7 -- set to Buyouts
			abiPresets[abiloop][31]=0
			abiPresets[abiloop][32]="2.40"
		end
	end


	if abiPriceIndex==nil then
		abiPriceIndex={}
	end

	if abiPriceIndex[abiRealm]==nil then
		abiPriceIndex[abiRealm]={}
	end

	if abiLastZero==nil then
		abiLastZero=0
	end

end



function pettoolshow()
	local f=GetMouseFocus()
	local n=f:GetName()

	if string.sub(n,1,8)=="MailItem" or string.sub(n,1,8)=="OpenMail" then
		return
	end

	CreateFrame("GameToolTip","abiBPtip",UIParent,"GameTooltipTemplate")
	abiBPtip:SetOwner(UIParent,"ANCHOR_NONE")

	abiBPtip:ClearLines()
	abiAddTooltipData(abiBPtip,abiTempName,1)
	abiBPtip:SetPoint("TOPLEFT",BattlePetTooltip,"BOTTOMLEFT",0,0)
	abiBPtip:Show()

end



function pettoolhide()

	if abiBPtip~=nil then
		abiBPtip:Hide()
	end
end



function abiDataFrame_OnLoad()
	abiDataFrame:Hide()
end



function abiProfitLossFrame_OnLoad()
	abiProfitLossFrame:Hide()
end



function abiResetTimeSeen()
	local L,BH,BL,SH,SL,RS,RB,RT,SN,TM,RH,RL,PH
	local s
	if abiPriceIndex[abiRealm]~=nil then
		for k,v in pairs(abiPriceIndex[abiRealm]) do
			L,BH,BL,SH,SL,RS,RB,RT,SN,TM,RH,RL,PH=abiDecodeIndex(abiPriceIndex[abiRealm][k])
			_,s=strsplit(":",SN)
			SN="0:"..s
			abiPriceIndex[abiRealm][k]=L.."%"..BH.."%"..BL.."%"..SH.."%"..SL.."%"..RS.."%"..RB.."%"..RT.."%"..SN.."%"..TM.."%"..RH.."%"..RL.."%x%"..PH
		end
	end
	
end



function abiCreateSnapShotButton_OnClick()
	abiResetTimeSeen()

	abiOptionsHelpText[1]=abiOptionsHelpText[3]
	abiHomeScreenFrame:RegisterEvent("AUCTION_ITEM_LIST_UPDATE")

	if abiScanType~=2 then

		local abiCanDoWholeQuery
		abiCanTakeSnapShot=0
   
		if abiTesting==0 and (time()-abiPresets[abiWhichPreset][1])<901 then
			return
		end

		if abiTesting==1 and (time()-abiPresets[abiWhichPreset][1])<61 then
			return
		end

		abiOptionsFrameHelp(2)

		abiBargains=table.wipe(abiBargains)
		abiBidBuyoutButton:SetChecked(false)
		abiLastByBuyout=0
		abiDisablePSButtons()

		abiCreateSnapShotButton:Disable()
		abiBargainSearchButton:Disable()
		abiCurrentMainButton:Disable()
		abiSelectWhichBidToUseButton:Disable()
		abiSelectScanTypeButton:Disable()
		_,abiCanDoWholeQuery=CanSendAuctionQuery("list")

		while abiCanDoWholeQuery==false do
			HowmanySecondsDelay(2) -- just prevents hammering the CanSendAuctionQuery
			_,abiCanDoWholeQuery=CanSendAuctionQuery("list")
		end 

		abiAreWeReadingTheAH=1 -- sets as waiting for event
		abiAHImage=table.wipe(abiAHImage)
		abiPresets[1][1]=time()
		abiPresets[2][1]=time()
		abiPresets[3][1]=time()
		abiPresets[4][1]=time()
		abiPresets[5][1]=time()
		abiPresets[6][1]=time()


		-- if needed, start the Auctionator timer countdowns

		if (IsAddOnLoaded("Auctionator")) then
			AUCTIONATOR_LAST_SCAN_TIME = time()
			gFullScanStart = time()
			gFullScanDur   = nil
		end


		if abiTesting==0 then
			QueryAuctionItems("",0,0,0,0,0,0,false,0,true)
		else
			QueryAuctionItems("Silk",0,0,0,0,0,0) -- this line used for testing only
		end

		-- routine finishes and waits for the event handler to call the routine to actually read the AH data
		return
	end

	if abiScanType==2 then
		abiBargainSearchButton:Disable()
		abiCreateSnapShotButton:Disable()
		abiSelectScanTypeButton:Disable()
		abiSelectWhichBidToUseButton:Disable()
		abiCurrentMainButton:Disable()
		abiDisablePSButtons()
		abiAHImage=table.wipe(abiAHImage)
		abiSB=table.wipe(abiSB)
		abiMyTempAuctions=abiMyAuctions
		abiMyTempBids=abiMyBids

		temp=false

		while temp==false do
			temp,temp2=CanSendAuctionQuery("list")
			HowmanySecondsDelay(1)
		end	

		abiGetNextSlowPage=1
		abiScanSlowPage=0
		abiDoingASlowScan=1
		return
	end
end


function abiUpdateRecentPrices(name,price)
	if abiPriceIndex[abiRealm][name]~=nil then
		local abiRH, abiRL, abiHT,abiLT
		abiLink1,abiBhigh1,abiBlow1,abiShigh1,abiSlow1,abiRsold1,abiRbought1,abiRatio1,abiSeen1,_,abiRecentHigh,abiRecentLow,abiPriceHistory=abiDecodeIndex(abiPriceIndex[abiRealm][name])
		abiRH,abiHT=strsplit(":",abiRecentHigh)
		abiRL,abiLT=strsplit(":",abiRecentLow)
		abiRH=tonumber(abiRH)
		abiRL=tonumber(abiRL)
		if price>abiRH then
			abiRecentHigh=price..":"..time()
		end
		if price<abiRL or abiRL==0 then
			abiRecentLow=price..":"..time()
		end
		abiPriceIndex[abiRealm][name]=abiLink1.."%"..tostring(abiBhigh1).."%"..tostring(abiBlow1).."%"..tostring(abiShigh1).."%"..tostring(abiSlow1).."%"..tostring(abiRsold1).."%"..tostring(abiRbought1).."%"..abiRatio1.."%"..abiSeen1.."%"..time().."%"..abiRecentHigh.."%"..abiRecentLow.."%x%"..abiPriceHistory
	end
end




function abiReadTheAuctionHouse()
	-- Use the abiSB table to store the number of times an item seen
	abiSB=table.wipe(abiSB) -- clear it
	abiAreWeReadingTheAH=0 -- trying to stop abigail reading the AH twice
	abiAHImage=table.wipe(abiAHImage) -- if it is read twice, at least only store it once.
	local abiDuration
	local abiBid,k,v
	local abiLastSeenTime
	abiMyTempAuctions=abiMyAuctions
	abiMyTempBids=abiMyBids

	for abiScannedItem=1,abiHowManyAuctions do

		abiname,_,abicount,_,_,_,_,abiminBid,abiminIncrement,abibuyoutPrice,abibidAmount,_,_,_,_,_,_=GetAuctionItemInfo("list",abiScannedItem)
		abiDuration=GetAuctionItemTimeLeft("list",abiScannedItem)
		if (abicount~=nil) and (abibuyoutPrice~=nil) and (abibuyoutPrice~=0) then
			abiItemLink=GetAuctionItemLink("list",abiScannedItem)
			abiBid=abiminBid

			if abibidAmount>0 then
				abiBid=abibidAmount+abiminIncrement
			end

			if CheckIfOneOfMyAuctions(abiname,abicount,abibuyoutPrice)==0 and CheckIfOneOfMyBids(abiname,abicount,abibidAmount)==0 and abiItemLink~=nil then
				abiAHImage[#abiAHImage+1]=abiname.."%"..abicount.."%"..abibuyoutPrice.."%"..abiItemLink.."%"..abiDuration.."%"..abiBid

				if abiSB[abiname]==nil then
					abiSB[abiname]=0
				end

				abiSB[abiname]=abiSB[abiname]+1
			end
		end

		-- waste some time so that it's less likely we cause disconnects
		-- This idea blatantly nicked from Auctionator
		-- Dont really know if it works - but it doesn't do any harm - so here it stays.
	
		for k = 1, 200 do
			v = math.acos (math.cos (42))
		end
	end

	if DeviationSlider:GetValue(abiPresets[abiWhichPreset][6])==0 then
		abiLastZero=time()
	end

	abiAreWeReadingTheAH=0
	abiAddSnapShotToPriceIndex()
	abiBargainSearchButton:Enable()
	abiCurrentMainButton:Enable()
	abiEnablePSButtons()
	abiOptionsFrameHelp(3)
	abiHomeScreenFrame:RegisterEvent("AUCTION_ITEM_LIST_UPDATE")
end



function abiAddSnapShotToPriceIndex()
	local abiNewItems=0
	local abiUpdatedItems=0
	local abiUniqueTable={}
	abiUniqueTable=table.wipe(abiUniqueTable)
	abiCurrentAuctions=table.wipe(abiCurrentAuctions)
	local t1,t2
	if abiPriceIndex[abiRealm]==nil then
		abiPriceIndex[abiRealm]={}
	end

	if #abiAHImage==0 or #abiAHImage==nil then
		return
	end

	for abiLoop=1,#abiAHImage do
		abiImageName,abiImageCount,abiImagePrice,abiItemLink,abiImageTime,abiImageBid=abiDecodeImage(abiAHImage[abiLoop])

		if (abiImageCount>1) then
			abiImagePrice=math.floor(abiImagePrice/abiImageCount) -- Price per unit, not per stack
		end

		if abiImagePrice<1 then
			abiImagePrice=1
	        	end

		-- First update the main Price Index file
		if abiPriceIndex[abiRealm][abiImageName]==nil then -- not seen before, needs adding to index file
			abiPriceIndex[abiRealm][abiImageName]={}
			abiPriceIndex[abiRealm][abiImageName]=abiItemLink.."%0%0%0%0%0:0%0:0%0:0%0:0%"..time().."%"..abiImagePrice..":"..time().."%"..abiImagePrice..":"..time().."%x%"..abiMakeFullPrice(abiImagePrice).."*1"
			abiNewItems=abiNewItems+1
		else
			abiLink1,abiBhigh1,abiBlow1,abiShigh1,abiSlow1,abiRsold1,abiRbought1,abiRatio1,abiSeen1,_,abiRecentHigh,abiRecentLow,abiPriceHistory=abiDecodeIndex(abiPriceIndex[abiRealm][abiImageName])
			abiDecodePriceHistory(abiPriceHistory)

			if strmatch(abiLink1, "[Nil Item]") then
				abiLink1=abiItemLink
			end

			if abiCheckDeviation(abiImagePrice)==1 then
				abiUpdatePriceHistory(abiImagePrice,1)
				abiPriceHistory=abiEncodePriceHistory()
			end

			abiPriceIndex[abiRealm][abiImageName]=abiLink1.."%"..tostring(abiBhigh1).."%"..tostring(abiBlow1).."%"..tostring(abiShigh1).."%"..tostring(abiSlow1).."%"..tostring(abiRsold1).."%"..tostring(abiRbought1).."%"..abiRatio1.."%"..abiSeen1.."%"..time().."%"..abiRecentHigh.."%"..abiRecentLow.."%x%"..abiPriceHistory

			if abiUniqueTable[abiImageName]==nil then
				abiUpdatedItems=abiUpdatedItems+1
			end
		end
		abiUpdateRecentPrices(abiImageName,abiImagePrice)

		-- Now update the current Price Index file
		if abiCurrentAuctions[abiImageName]==nil then -- not seen before, needs adding to index file
			abiCurrentAuctions[abiImageName]=abiItemLink.."%0%0%0%0%0:0%0:0%0:0%0:0%x%"..abiImagePrice..":"..time().."%"..abiImagePrice..":"..time().."%x%"..abiMakeFullPrice(abiImagePrice).."*1"
		else
			abiLink1,abiBhigh1,abiBlow1,abiShigh1,abiSlow1,abiRsold1,abiRbought1,abiRatio1,abiSeen1,_,abiRecentHigh,abiRecentLow,abiPriceHistory=abiDecodeIndex(abiCurrentAuctions[abiImageName])
			abiDecodePriceHistory(abiPriceHistory)

			if strmatch(abiLink1, "[Nil Item]") then
				abiLink1=abiItemLink
			end

			-- No longer check for Deviation, so the Price History file is made up of ALL current prices for this item
			abiUpdatePriceHistory(abiImagePrice,1)
			abiPriceHistory=abiEncodePriceHistory()

			abiCurrentAuctions[abiImageName]=abiLink1.."%"..tostring(abiBhigh1).."%"..tostring(abiBlow1).."%"..tostring(abiShigh1).."%"..tostring(abiSlow1).."%"..tostring(abiRsold1).."%"..tostring(abiRbought1).."%"..abiRatio1.."%"..abiSeen1.."%x%"..abiImagePrice..":"..time().."%"..abiImagePrice..":"..time().."%x%"..abiPriceHistory
		end

		abiUniqueTable[abiImageName]="Found"
	end

	for k,v in pairs(abiSB) do
		abiLink1,abiBhigh1,abiBlow1,abiShigh1,abiSlow1,abiRsold1,abiRbought1,abiRatio1,abiSeen1,abiTimeStamp,abiRecentHigh,abiRecentLow,abiPriceHistory=abiDecodeIndex(abiPriceIndex[abiRealm][k])
		_,t2=strsplit(":",abiSeen1)
		t1=abiSB[k]
		t2=tonumber(t2)+abiSB[k]
		abiSeen1=t1..":"..t2
		abiPriceIndex[abiRealm][k]=abiLink1.."%"..tostring(abiBhigh1).."%"..tostring(abiBlow1).."%"..tostring(abiShigh1).."%"..tostring(abiSlow1).."%"..tostring(abiRsold1).."%"..tostring(abiRbought1).."%"..abiRatio1.."%"..abiSeen1.."%"..abiTimeStamp.."%"..tostring(abiRecentHigh).."%"..tostring(abiRecentLow).."%x%"..abiPriceHistory

		abiLink1,abiBhigh1,abiBlow1,abiShigh1,abiSlow1,abiRsold1,abiRbought1,abiRatio1,abiSeen1,_,abiRecentHigh,abiRecentLow,abiPriceHistory=abiDecodeIndex(abiCurrentAuctions[k])
		t1=abiSB[k]
		abiSeen1=t1..":"..t1
		abiCurrentAuctions[k]=abiLink1.."%"..tostring(abiBhigh1).."%"..tostring(abiBlow1).."%"..tostring(abiShigh1).."%"..tostring(abiSlow1).."%"..tostring(abiRsold1).."%"..tostring(abiRbought1).."%"..abiRatio1.."%"..abiSeen1.."%x%"..abiRecentHigh.."%"..abiRecentLow.."%x%"..abiPriceHistory
	end


	abiSelectScanTypeButton:Enable()
	abiSelectWhichBidToUseButton:Enable()
	print("Total Buyout Auctions Scanned : "..#abiAHImage)
	print("New Items Added To Database : "..abiNewItems)
	print("Records Updated : "..abiUpdatedItems)

	-- now add the information to the playerlist table

	local index=GetRealmName()..abiMyFaction
	if abiPlayerList==nil then
			abiPlayerList={}
	end
	abiPlayerList[index]=GetRealmName().."%"..abiMyFaction.."%"..UnitName("Player").."%"..time()
end



function abiBargainSearchButton_OnClick()
	local extratext=" - Full Pricing Data"
	abiTableOffset=0

	if abiPriceIndex[abiRealm]==nil then
		abiPriceIndex[abiRealm]={}
	end --just making sure

	local abiItemAverage
	local abiType
	local abiTempBuyout
	local abiTempBid
	local abiMySoldLow
	local abiSingleTable={}
	abiBargains=table.wipe(abiBargains)
	abiSB=table.wipe(abiSB)
	abiScrollFrame1:SetVerticalScroll(0)

	if abiCurrent==1 then
		extratext=" - Current Pricing Data"
	end
	abiLastSearchText=abiBidTimeTable[abiBidTime]

	if abiBidTime==5 then
		abiLastSearch="Undercuts"
		abiLastByBuyout=0
	end

	if abiBidTime==7 then
		abiLastSearch="Single Items"
		abiLastByBuyout=0

		for abiScannedItem=1,#abiAHImage do
			abiImageName,abiImageCount,abiImagePrice,abiItemLink,abiImageTime,abiImageBid=abiDecodeImage(abiAHImage[abiScannedItem])
			if abiSingleTable[abiImageName]==nil then
				abiSingleTable[abiImageName]=1
			else
				abiSingleTable[abiImageName]=abiSingleTable[abiImageName]+1
			end
		end
	end

	if abiBidTime==8 then
		abiLastSearch="Bargains"
		abiLastByBuyout=0
	end

	if abiBidTime==6 then
		abiLastSearch="My Profits"
		abiLastByBuyout=0
	end

	if abiBidTime<5 then
		abiLastSearch="Bids"
		if abiBidBuyoutButton:GetChecked()==false then
			abiLastByBuyout=1
		else
			abiLastByBuyout=0
		end
	end


	if abiBidTime==5 then
		abiGetMyAuctions()
		local abiAuctionName,abiAuctionCount,abiAuctionBuyout,abiUnderPrice,abiWhichBargain
		abiWhichBargain=1

		for abiloop=1,#abiMyAuctions do

			abiAuctionName,abiAuctionCount,abiAuctionBuyout=strsplit("%",abiMyAuctions[abiloop])
			abiAuctionCount=tonumber(abiAuctionCount)
			abiAuctionBuyout=tonumber(abiAuctionBuyout)
			abiAuctionBuyout=math.floor(abiAuctionBuyout/abiAuctionCount)

			for abiloop2=1,#abiAHImage do

				abiname,abicount,abibuyoutPrice,abiItemLink,abiDuration,abiBid=abiDecodeImage(abiAHImage[abiloop2])
				abibuyoutPrice=math.floor(abibuyoutPrice/abicount)

				if abiAuctionName==abiname and abibuyoutPrice<abiAuctionBuyout then

					if abiBargains[abiWhichBargain]==nil then
						abiBargains[abiWhichBargain]="TempName%0%9999999999%0%0"
					end

					_,_,abiUnderPrice,_,_=strsplit("%",abiBargains[abiWhichBargain])
					abiUnderPrice=tonumber(abiUnderPrice)

					if abibuyoutPrice<abiUnderPrice then
						abiBargains[abiWhichBargain]="("..abiAuctionCount..") "..abiAuctionName.."%"..abiAuctionBuyout.."%"..abibuyoutPrice.."%"..abiDuration.."%"..abicount.."%"..abiloop
					end
				end

			end

			if abiBargains[abiWhichBargain]~=nil then
				abiWhichBargain=abiWhichBargain+1
			end
		end
	else

		for abiScannedItem=1,#abiAHImage do

			abiImageName,abiImageCount,abiImagePrice,abiItemLink,abiImageTime,abiImageBid=abiDecodeImage(abiAHImage[abiScannedItem])

			_,_,_,_,_,abiType,_,_,_,_=GetItemInfo(abiItemLink)

			if strmatch(abiItemLink,"battlepet") then
				abiType="Battle Pets"
			end

			abiTempBuyout=abiImagePrice
			abiTempBid=abiImageBid

			if abiCheckTheType(abiType)==1 and abiImageName~="This Item No Longer Available" then

				if abiImageCount>1 then
					abiImagePrice=math.floor(abiImagePrice/abiImageCount)
					abiImageBid=math.floor(abiImageBid/abiImageCount)
				end --this used to make the price per unit and not per stack

				if abiCurrent==0 then
					_,_,_,_,abiMySoldLow,_,_,_,_,_,_,_,abiPriceHistory=abiDecodeIndex(abiPriceIndex[abiRealm][abiImageName])
				else
					_,_,_,_,abiMySoldLow,_,_,_,_,_,_,_,abiPriceHistory=abiDecodeIndex(abiCurrentAuctions[abiImageName])
				end
				abiMySoldLow=tonumber(abiMySoldLow)

				abiDecodePriceHistory(abiPriceHistory)
				abiFindHighestPrice()
				abiItemAverage=abiFindAveragePrice() -- price index average price
				-- abiImagePrice is the buyout price per unit .

				-- Check for My Profits search
				if abiCheckMyProfits(abiImagePrice,abiMySoldLow)==1 and abiBidTime==6 then
					if abiStackUnitPrices==1 then
					
abiBargains[#abiBargains+1]=abiMakeFullPrice(abiMySoldLow-abiImagePrice).."%"..tostring(abiScannedItem)

					else
						
abiBargains[#abiBargains+1]=abiMakeFullPrice((abiMySoldLow-abiImagePrice)*abiImageCount).."%"..tostring(abiScannedItem)

					end
				end

				-- Check for Single Item search
				if abiBidTime==7 then

					if abiSingleTable[abiImageName]==1 then

						if abiCheckThePrice(abiImagePrice,abiItemAverage,abiTempBuyout)==1 then
							if abiStackUnitPrices==1 then
								abiBargains[#abiBargains+1]=abiMakeFullPrice(abiItemAverage-abiImagePrice).."%"..tostring(abiScannedItem)
							else
								abiBargains[#abiBargains+1]=abiMakeFullPrice((abiItemAverage*abiImageCount)-abiTempBuyout).."%"..tostring(abiScannedItem)
							end
						end
					end
				end

				-- Check for standard Buyout search
				if abiCheckThePrice(abiImagePrice,abiItemAverage,abiTempBuyout)==1 and abiBidTime==8 then
					if abiStackUnitPrices==1 then
						abiBargains[#abiBargains+1]=abiMakeFullPrice(abiItemAverage-abiImagePrice).."%"..tostring(abiScannedItem)
					else
						abiBargains[#abiBargains+1]=abiMakeFullPrice((abiItemAverage*abiImageCount)-abiTempBuyout).."%"..tostring(abiScannedItem)
					end
				end

				-- Check for Bid search, against price history prices
				if abiCheckThePrice(abiImageBid,abiItemAverage,abiTempBid)==1 and abiBidTime<5 and abiBidBuyoutButton:GetChecked()==false and abiImageTime<=abiBidTime then
					abiBargains[#abiBargains+1]=abiMakeFullPrice((abiItemAverage*abiImageCount)-abiTempBid).."%"..tostring(abiScannedItem)
				end

				-- Check for Bid search, against its buyout price
				if abiCheckThePrice(abiImageBid,abiImagePrice,abiTempBid)==1 and abiBidTime<5 and abiBidBuyoutButton:GetChecked()==true and abiImageTime<=abiBidTime then
					abiBargains[#abiBargains+1]=abiMakeFullPrice(abiTempBuyout-abiTempBid).."%"..tostring(abiScannedItem)
				end

			end

		end
	end

	if #abiBargains==0 then

		abiBargainsString:SetText("Bids Found : Nil")

		if abiBidTime==5 then
			abiBargainsString:SetText("Undercuts Found : Nil")
			return
		end

		if abiBidTime>6  then
			abiBargainsString:SetText("Bargains Found : Nil")
		end

		if abiBidTime==6 then
			abiBargainsString:SetText("My Profits Found : Nil")
		end

		return
	end

	if abiBidTime~=5 then
		table.sort(abiBargains,abiHighLow) -- this is to make sure the MaxSame returns the best-value items.
		abiCheckMaxSameValue()
	end
	
	if abiBidTime==5 then
		abiBargainsString:SetText("Undercuts Found : "..#abiBargains)
		return
	end

	if abiBidTime>6 then
		abiBargainsString:SetText("Bargains Found : "..#abiBargains)
	end

	if abiBidTime==6 then
		abiBargainsString:SetText("My Profits Found : "..#abiBargains)
	end

	if abiBidTime<5 then
		abiBargainsString:SetText("Bids Found : "..#abiBargains)
	end

end


function abiCheckMyProfits(p,s)-- buyoutprice,soldlow
-- returns 1 if ok, 0 if not
-- compares current price against abiSlow1.
	p=p+((p*ProfitMarginSlider:GetValue())/100)
	local ret=0
	if s>p then
		ret=1
	end
	return ret
end




function abiCheckMaxSameValue()

	if MaxSameSlider:GetValue()==0 then
		return
	end
	
	local name,number
	
	for abiloop=1,#abiBargains do

		_,number=strsplit("%",abiBargains[abiloop])
		number=tonumber(number)
		name,_,_,_,_,_=strsplit("%",abiAHImage[number])

		if abiSB[name]==nil then
			abiSB[name]=0
		end

		abiSB[name]=abiSB[name]+1

		if abiSB[name]>MaxSameSlider:GetValue() then
			abiBargains[abiloop]="Take%Out"
		end

	end

	for abiloop=#abiBargains,1,-1 do

		name,number=strsplit("%",abiBargains[abiloop])

		if name=="Take" and number=="Out" then
			table.remove(abiBargains,abiloop)
		end

	end
end



function abiShowTheBargains() --got the desired items in abiBargains()
	abiScrollFrame1Update()
	abiSetBargainsHeaders()
	abiDisplayTheItems()
end



function abiSetBargainsHeaders()
	
	local extratext=" - Full Pricing Data"
	if abiCurrent==1 then
		extratext=" - Current Pricing Data"
	end

	if abiLastSearch=="Undercuts" then
		abiShowingFiveButton:Disable()
		abiStackUnitButton:Disable()
		abiTH1:SetText("Auction Item")
		abiTH2:SetText("My Buyout")
		abiTH3:SetText("Undercut Price")
		abiTH4:SetText("Duration")
		abiTH5:SetText("Stack")
		abiBargainsHeader:SetText("Abigail 2.40 - Check My Auctions for Undercuts")
		for abiloop=1,13 do
			_G["abiButton"..abiloop]:SetText("|cffffffffEnd")
		end
		abiTH1.tooltipText="|cffffff00Your auction that is being undercut."
		abiTH2.tooltipText="|cffffff00The buyout value of my auction."
		abiTH3.tooltipText="|cffffff00The buyout value of|nthe auction undercutting mine."
		abiTH4.tooltipText="|cffffff00How long the undercutting auction|n has left to go."
		abiTH5.tooltipText="|cffffff00The stack size of the undercutting auction."
		return
	end

	abiShowingFiveButton:Enable()
	abiStackUnitButton:Enable()

	if abiLastSearch=="Bargains" or abiLastSearch=="My Profits" or abiLastSearch=="Single Items" then
		abiTH1:SetText("Items For Sale")
		abiTH2:SetText("Buyout")
		abiTH3:SetText("Average")
		abiTH4:SetText("Profit")
		abiTH5:SetText("%age")
		abiTH1.tooltipText="|cffffff00The item that is considered a bargain."
		abiTH2.tooltipText="|cffffff00The buyout value for this item."
		abiTH3.tooltipText="|cffffff00The average price of this item."
		abiTH4.tooltipText="|cffffff00The expected profit if you re-sell|nthis item at its Average price."
		abiTH5.tooltipText="|cffffff00The %age profit if re-sold at|nthe Average Price."

		if abiLastSearch=="Bargains" or abiLastSearch=="Single Items" then
			abiBargainsHeader:SetText("Abigail 2.40 - Bargain Search Results"..extratext)
		else
			abiBargainsHeader:SetText("Abigail 2.40 - My Profit Search Results"..extratext)
			abiTH3:SetText("My Sold Low")
			abiTH3.tooltipText="|cffffff00The lowest price you|nhave sold for it for."
			abiTH4.tooltipText="|cffffff00The expected profit if you re-sell|nthis item at its Sold Low price."
		end

		for abiloop=1,13 do
			_G["abiButton"..abiloop]:SetText("|cffffffffBuy")
		end
	end

	if abiLastSearch=="Bids" then
		abiTH1:SetText("Items For Sale")
		abiTH2:SetText("Bid")
		abiTH3:SetText("Buyout")
		abiTH4:SetText("Difference")
		abiTH5:SetText("%age")
		abiBargainsHeader:SetText("Abigail 2.40 - Bid Search Results"..extratext)

		for abiloop=1,13 do
			_G["abiButton"..abiloop]:SetText("|cffffffffBid")
		end
		abiTH1.tooltipText="|cffffff00The item that you can bid on."
		abiTH2.tooltipText="|cffffff00How much you'll have to bid|non this item."
		abiTH3.tooltipText="|cffffff00The buyout price of this item."
		abiTH4.tooltipText="|cffffff00The expected profit if you re-sell|nthis item at its Buyout Price."
		abiTH5.tooltipText="|cffffff00The %age profit if re-sold|nat the Buyout Price."

		if abiLastByBuyout==0 then
			abiTH3:SetText("Average")
			abiTH4:SetText("Profit")
			abiTH3.tooltipText="|cffffff00The average price of this item|nbased on the price history."
			abiTH4.tooltipText="|cffffff00The expected profit if you re-sell|nthis item at its Average price."
			abiTH5.tooltipText="|cffffff00The %age profit if re-sold|nat the Average Price."

		end
	end
	
	if abiLastSearch=="Shopping" then
		abiTH1:SetText("Items For Sale")
		abiTH2:SetText("Buyout")
		abiTH3:SetText("Average")
		abiTH4:SetText("Profit")
		abiTH5:SetText("%age")
		abiBargainsHeader:SetText("Abigail 2.40 - Shopping List Search Results"..extratext)

		for abiloop=1,13 do
			_G["abiButton"..abiloop]:SetText("|cffffffffBuy")
		end
		abiTH1.tooltipText="|cffffff00The item that is considered a bargain."
		abiTH2.tooltipText="|cffffff00The buyout value of this item."
		abiTH3.tooltipText="|cffffff00The average price of this item."
		abiTH4.tooltipText="|cffffff00The expected profit if you re-sell|nthis item at its Average Price."
		abiTH5.tooltipText="|cffffff00The %age profit if re-sold|nat the Average Price."
	end
end



function abiDisplayTheItems()
	abiCreatePricingFrames()
	local value1,value2
	local abiPercent
	local abiStart
	local abiFinish
	local abiOneToThirteen
	local abiFullName
	local abiSoldLow
	local abiUnderName,abiUnderBuyout,abiUndercut,abiUnderDur,abiUnderCount,abiUnderAuction

	abiClearExtraInformation()

	for abiloop=1,13 do

		_G["abiFS"..abiloop.."1"]:SetText("empty")
		_G["abiFS"..abiloop.."2"]:Hide()
		_G["abiFS"..abiloop.."3"]:Hide()
		_G["abiFS"..abiloop.."4"]:Hide()
		_G["abiFS"..abiloop.."5"]:Hide()
		_G["abiFS"..abiloop.."6"]:Hide()
		_G["abiButton"..abiloop]:Disable()
		_G["abiButton"..abiloop]:Show()

	end

	abiStart=1+abiTableOffset
	abiFinish=13+abiTableOffset

	if abiFinish>#abiBargains then
		abiFinish=#abiBargains
	end

	if abiStart<=abiFinish then

		for abidisplayloop=abiStart,abiFinish do

			abiOneToThirteen=abidisplayloop-abiStart+1

			-- Get the values for fields 2(Buyout) and 3(Undercut)

			if abiLastSearch=="Undercuts" then
				abiFullName,abiUnderBuyout,abiUnderCut,abiUnderDur,abiUnderCount,abiUnderAuction=strsplit("%",abiBargains[abidisplayloop])
				abiUnderDur=tonumber(abiUnderDur)
				abiValue1=abiUnderBuyout
				abiValue2=abiUnderCut
			end


			if abiLastSearch=="Bargains" or abiLastSearch=="Shopping" or abiLastSearch=="My Profits" or abiLastSearch=="Single Items" then
				abiMoneyValue,abiImageNumber=strsplit("%",abiBargains[abidisplayloop])
				abiImageNumber=tonumber(abiImageNumber)

				-- Get info from abiAHImage File
				abiImageName,abiImageCount,abiImagePrice,abiItemLink,abiImageTime,abiImageBid=abiDecodeImage(abiAHImage[abiImageNumber])
				abiValue1=abiImagePrice

				if abiCurrent==0 then
					_,_,_,_,abiSoldLow,_,_,_,_,_,_,_,abiPriceHistory=abiDecodeIndex(abiPriceIndex[abiRealm][abiImageName])
				else
					_,_,_,_,abiSoldLow,_,_,_,_,_,_,_,abiPriceHistory=abiDecodeIndex(abiCurrentAuctions[abiImageName])
				end

				abiDecodePriceHistory(abiPriceHistory)

				abiValue2=abiFindAveragePrice()
				if abiLastSearch=="My Profits" then
					abiValue2=abiSoldLow
				end

				if abiStackUnitPrices==0 then
					abiValue2=abiValue2*abiImageCount -- per stack

				else
					abiValue1=math.floor(abiValue1/abiImageCount)
				end
				abiFullName=tostring(abiImageCount).." x "..abiImageName
				if abiImageName=="This Item No Longer Available" then
					abiFullName="This Item No Longer Available"
				end

			end


			if abiLastSearch=="Bids" then
				abiMoneyValue,abiImageNumber=strsplit("%",abiBargains[abidisplayloop])
				abiImageNumber=tonumber(abiImageNumber)

				-- Get info from abiAHImage File
				abiImageName,abiImageCount,abiImagePrice,abiItemLink,abiImageTime,abiImageBid=abiDecodeImage(abiAHImage[abiImageNumber])
				abiValue1=abiImageBid

				if abiCurrent==0 then
					_,_,_,_,_,_,_,_,_,_,_,_,abiPriceHistory=abiDecodeIndex(abiPriceIndex[abiRealm][abiImageName])
				else
					_,_,_,_,_,_,_,_,_,_,_,_,abiPriceHistory=abiDecodeIndex(abiCurrentAuctions[abiImageName])
				end

				abiDecodePriceHistory(abiPriceHistory)

				-- note abiValue2 needs to be a full stack price - not just per item price
				if abiLastByBuyout==1 then
					abiValue2=abiImagePrice
				else
					abiValue2=abiFindAveragePrice()*abiImageCount
				end


				-- abiValue2 is now reduced to per-item price if needed
				if abiStackUnitPrices==1 then
					abiValue1=math.floor(abiValue1/abiImageCount)
					abiValue2=math.floor(abiValue2/abiImageCount)
				end
				abiFullName=tostring(abiImageCount).." x "..abiImageName
				if abiImageName=="This Item No Longer Available" then
					abiFullName="This Item No Longer Available"
				end

			end

			if abiFullName=="This Item No Longer Available" then
				abiValue1=0
				abiValue2=0
				_G["abiButton"..abiOneToThirteen]:Disable()
				abiPercent="0"


			else
				abiPercent=((abiValue2-abiValue1)/abiValue1)
				abiPercent=math.floor(abiPercent*100)
				if abiPercent>99999 then
					abiPercent="+99999"
				end
				_G["abiButton"..abiOneToThirteen]:Enable()
			end

			_G["abiFS"..abiOneToThirteen.."1"]:SetText(abiFullName)
			AbigailMoneyFrame_Update(_G["abiFS"..abiOneToThirteen.."2"],abiValue1,0,"|cffffffff")
			AbigailMoneyFrame_Update(_G["abiFS"..abiOneToThirteen.."4"],abiValue2-abiValue1,0,"|cffffffff")

			if abiLastSearch=="Undercuts" then
				_G["abiFS"..abiOneToThirteen.."6"]:SetText(abiFullDurTable[abiUnderDur])
				AbigailMoneyFrame_Update(_G["abiFS"..abiOneToThirteen.."3"],abiUnderCut,0,"|cffffffff")
				_G["abiFS"..abiOneToThirteen.."5"]:SetText(abiUnderCount)
				_G["abiFS"..abiOneToThirteen.."6"]:Show()
				_G["abiFS"..abiOneToThirteen.."4"]:Hide()
			else
				AbigailMoneyFrame_Update(_G["abiFS"..abiOneToThirteen.."3"],abiValue2,0,"|cffffffff")
				_G["abiFS"..abiOneToThirteen.."5"]:SetText(abiPercent)
				_G["abiFS"..abiOneToThirteen.."4"]:Show()
			end

			_G["abiFS"..abiOneToThirteen.."1"]:Show()
			_G["abiFS"..abiOneToThirteen.."2"]:Show()
			_G["abiFS"..abiOneToThirteen.."3"]:Show()
			_G["abiFS"..abiOneToThirteen.."5"]:Show()

		end

	end

	abiShowingWhichBargainsString:SetText("|cffffffff"..tostring(abiStart).." to "..tostring(abiFinish).." of "..#abiBargains.." ")
	abiShowingWhichBargainsString:Show()
	abiBargainsLastSearch:SetText("Result of last search : "..abiLastSearchText)
end



function abiScrollFrame1Update()
	local f

	if abiDisplayingFiveAuctions>0 then

		abiFiveBestFrame:Hide()

		for abiloop=1,13 do

			_G["abiFS"..abiloop.."1"]:Show()

			if abiloop<=#abiBargains then

				_G["abiFS"..abiloop.."2"]:Show()
				_G["abiFS"..abiloop.."3"]:Show()
				_G["abiFS"..abiloop.."4"]:Show()
				_G["abiFS"..abiloop.."5"]:Show()
			end
		end

		abiFadeBargains(1)
		abiDisplayingFiveAuctions=0
	end

	if #abiBargains~=0 then

		FauxScrollFrame_Update(abiScrollFrame1,#abiBargains,13,23)
		-- #abiBargains is max entries, 13 is number of lines, 23 is pixel height of each line
		abiTableOffset=FauxScrollFrame_GetOffset(abiScrollFrame1)
		abiDisplayTheItems()
		abiScrollFrame1:Show()
		f=GetMouseFocus()

		if f then

			f=f:GetName() or tostring(f)

			if f~=nil then

				if string.sub(f,1,15)=="abiMessageFrame" then

					f=string.sub(f,16)
					f=tonumber(f)
					abiDisplayExtraInformation(f,0)

				end

			end

		end

	end

end



function abiMessageFrame_OnEnter(value,passed)

	if abiDoingABuyout==1 or abiLastSearch=="Undercuts" then
		return
	end

	local t

	if abiPopupShown==0 and abiDisplayingFiveAuctions==0 then

		local abiImageNumber
		local abiLinkNumber
		local abiProfit
		_G["abiFS"..value.."1"]:SetTextColor(1,1,1,1)
		_G["abiFS"..value.."1"]:SetFontObject("GameFontNormalLarge")
		abiLinkNumber=value+abiTableOffset

		if abiLinkNumber<=#abiBargains then

			abiDisplayExtraInformation(value,passed)
			if abiShowingFive==2 then
				abiBargainsFrameHelp(8)
			else
				abiBargainsFrameHelp(5)
			end

			_,abiImageNumber,_=strsplit("%",abiBargains[abiLinkNumber])
			abiImageNumber=tonumber(abiImageNumber)

			-- Get info from abiAHImage File
			abiImageName,abiStackSize,_,abiItemLink,_,_=abiDecodeImage(abiAHImage[abiImageNumber])
			abiPresets[abiWhichPreset][24]=abiStackSize

			if passed==1 then

				if abiBidTime>6 then
					abiBargainsFrameHelp(6)
				else
					abiBargainsFrameHelp(7)
				end

				abiOnTheButton=1

				-- show the tooltip for this item
				if strmatch(abiItemLink,"battlepet") then

					GameTooltip:SetOwner(abiDataFrame,"ANCHOR_CURSOR")
					GameTooltip:ClearLines()
					GameTooltip:AddLine("Battle Pet")
					GameTooltip:AddLine("|cffffffff"..abiImageName)
					abiAddTooltipData(GameTooltip,abiImageName,0)
					GameTooltip:Show()
				else
					GameTooltip:SetOwner(abiDataFrame,"ANCHOR_CURSOR")
					GameTooltip:SetHyperlink(abiItemLink)
					GameTooltip:Show()
				end
			end

		end
	end
end



function abiDisplayExtraInformation(passed,p2) --passed is 1-13
	abiHidePerUnitInfo()
	abiFadeBargains(1)
	local abiTempCost
	local abiHighlightDone=0
	-- function needs to show the (upto) 15 prices stored for this item
	_,abiImageNumber=strsplit("%",abiBargains[passed+abiTableOffset])
	abiImageNumber=tonumber(abiImageNumber)
	abiImageName,abiImageCount,abiImagePrice,_,_,_=abiDecodeImage(abiAHImage[abiImageNumber])
	abiImagePrice=math.floor(abiImagePrice/abiImageCount) -- now per unit
	
	if abiImageName~="This Item No Longer Available" then

		if abiCurrent==0 then
			_,_,_,_,_,_,_,_,_,_,_,_,abiPriceHistory=abiDecodeIndex(abiPriceIndex[abiRealm][abiImageName])
		else
			_,_,_,_,_,_,_,_,_,_,_,_,abiPriceHistory=abiDecodeIndex(abiCurrentAuctions[abiImageName])
		end

		abiDecodePriceHistory(abiPriceHistory)

		for abiloop=15,1,-1 do 

			abiTempCost=abiHistoryCost[abiloop]

			if (abiHistorySeen[abiloop]~=nil) and (abiHistorySeen[abiloop]>0) then

				if abiCheckButton2:GetChecked()==true then
					abiTempCost=abiTempCost*abiImageCount
				end

				if (abiImagePrice>=abiHistoryCost[abiloop]*0.9) and (abiImagePrice<=abiHistoryCost[abiloop]*1.1) and abiHighlightDone==0 then
					AbigailMoneyFrame_Update(_G["abiPS"..abiloop],abiTempCost,abiHistorySeen[abiloop],"|cffff4040")
					abiHighlightDone=1
				else
					AbigailMoneyFrame_Update(_G["abiPS"..abiloop],abiTempCost,abiHistorySeen[abiloop],"|cffffffff")
				end

				_G["abiPS"..abiloop]:Show()
			end

		end


		if abiImageCount>1 then
			abiUPF11:Show()
			abiImageName,abiImageCount,abiImagePrice,abiItemLink,abiImageTime,abiImageBid=abiDecodeImage(abiAHImage[abiImageNumber])
			if abiLastSearch=="Bids" then
				abiUPF12:SetText("Bid :")
				AbigailMoneyFrame_Update("abiUPF22",math.floor(abiImageBid/abiImageCount),0,"|cffffffff")
				abiUPF13:SetText("Buy :")
				AbigailMoneyFrame_Update("abiUPF23",math.floor(abiImagePrice/abiImageCount),0,"|cffffffff")
					
				abiProfit=abiFindAveragePrice()-math.floor(abiImageBid/abiImageCount)
				abiUPF14:SetText("Avg :")
				abiUPF15:SetText("Profit :")
				AbigailMoneyFrame_Update("abiUPF24",abiFindAveragePrice(),0,"|cffffffff")
				AbigailMoneyFrame_Update("abiUPF25",abiProfit,0,"|cffffffff")
				abiUPF12:Show()
				abiUPF13:Show()
				abiUPF14:Show()
				abiUPF15:Show()
				abiUPF22:Show()
				abiUPF23:Show()
				abiUPF24:Show()
				abiUPF25:Show()
			end

			if abiLastSearch=="Bargains" or abiLastSearch=="Shopping" or abiLastSearch=="My Profits" or abiLastSearch=="Single Items" then
				abiUPF13:SetText("Buy :")
				AbigailMoneyFrame_Update("abiUPF23",math.floor(abiImagePrice/abiImageCount),0,"|cffffffff")
				abiProfit=abiFindAveragePrice()-math.floor(abiImagePrice/abiImageCount)
				abiUPF14:SetText("Avg :")
				abiUPF15:SetText("Profit :")
				AbigailMoneyFrame_Update("abiUPF24",abiFindAveragePrice(),0,"|cffffffff")
				AbigailMoneyFrame_Update("abiUPF25",abiProfit,0,"|cffffffff")
				abiUPF13:Show()
				abiUPF14:Show()
				abiUPF15:Show()
				abiUPF23:Show()
				abiUPF24:Show()
				abiUPF25:Show()
			end
		end
	end
end



function abiMessageFrame_OnLeave(value)
	if abiDoingABuyout==1 or abiLastSearch=="Undercuts" then
		return
	end

	if abiPopupShown==0 then

		abiHidePerUnitInfo()
		abiPutTextBackToNormal()

		if abiPopupShown==0 then
			abiClearExtraInformation()
		end

		GameTooltip:FadeOut()
		abiOnTheButton=0
		abiBargainsFrameHelp(1)

		abiDisplayingFiveAuctions=0
		abiBestFiveButtonPressed=0

		abiFiveBestFrame:Hide()
		for abiloop=1,13 do

		_G["abiFS"..abiloop.."1"]:Show()

			if abiloop<=#abiBargains then

				_G["abiFS"..abiloop.."2"]:Show()
				_G["abiFS"..abiloop.."3"]:Show()
				_G["abiFS"..abiloop.."4"]:Show()
				_G["abiFS"..abiloop.."5"]:Show()
			end

		end

		abiFadeBargains(1)

	end
end



function abiBuyButtonClicked(passed,button)
	local abiAuctionNumber
	-- check if we are cancelling an auction

	if abiBidTime==5 then

		abiBuyThisItem=passed+abiTableOffset
		AuctionFrame:SetAlpha(0.5)
		StaticPopup_Show("abiCancelAuction")
		return

	end

	-- could also be a Bid
	abiMyAuctionPlaced=0 --just make sure

	if abiPopupShown==1 then
		return
	end

	if button=="RightButton" then

		if abiCheckButton2:GetChecked()==false then
			abiCheckButton2:SetChecked(true)
		else
			abiCheckButton2:SetChecked(false)
		end
		
		abiDisplayExtraInformation(passed,0)
		return
	end

	abiDoingABuyout=1
	local abiCanDoSearchQuery=false
	GameTooltip:FadeOut()
	_,abiBuyoutNumber=strsplit("%",abiBargains[passed+abiTableOffset])
	abiBuyoutNumber=tonumber(abiBuyoutNumber)
	abiBuying.name,abiBuying.count,abiBuying.price,_,_,abiBuying.bid=abiDecodeImage(abiAHImage[abiBuyoutNumber])

	while abiCanDoSearchQuery~=true do
		HowmanySecondsDelay(1) -- just prevents hammering the CanSendAuctionQuery
		abiCanDoSearchQuery,_=CanSendAuctionQuery("list")
	end

	abiBuyoutFound=0
	QueryAuctionItems(abiBuying.name)
	-- gets 1st page of this item, and waits for event to fire
end



function abiLookForTheItem()
	abiDoingABuyout=0 --stop the onevent / onupdate routines firing
	local abiDuration
	local abiBid
	b,_=GetNumAuctionItems("list")

	if b==0 then

		if abiBuyoutFound==0 then

			StaticPopup_Show("abiNoLongerInAH")
			abiImageName,abiImageCount,abiImagePrice,abiItemLink,abiImageTime,abiImageBid=strsplit("%",abiAHImage[abiBuyoutNumber])
			abiImageName="This Item No Longer Available"
			abiAHImage[abiBuyoutNumber]=abiImageName.."%0%0%0%0%0"
			abiPriceIndex[abiRealm][abiImageName]=abiNilLink.."%0%0%0%0%0:0%0:0%0:0%0:0%0%0:0%0:0%x%0000000001*1" -- record for This Item No Longer Available
			abiCurrentAuctions[abiImageName]=abiNilLink.."%0%0%0%0%0:0%0:0%0:0%0:0%0%0:0%0:0%x%0000000001*1" --  record for This Item No Longer Available
			abiDisplayTheItems()
			abiMyAuctionPlaced=0
		end

		abiPopupShown=0
		return

	end

	for abiloop=1,b do

		abiname,_,abicount,_,_,_,_,abiminBid,abiminIncrement,abibuyoutPrice,abibidAmount=GetAuctionItemInfo("list",abiloop)
		abiDuration=GetAuctionItemTimeLeft("list",abiloop)
			abiBid=abiminBid

			if abibidAmount>0 then
				abiBid=abibidAmount+abiminIncrement
			end

		if abiname==abiBuying.name and abicount==abiBuying.count and abibuyoutPrice==abiBuying.price and (abiBidTime>5) then
			abiBuyThisItem=abiloop
			abiBuyThisPrice=abibuyoutPrice
			abiPopupShown=1
			AuctionFrame:SetAlpha(0.5)
			StaticPopup_Show("abiBuyoutConfirm",abiCreatePriceStringIcons(abiBuyThisPrice,""))
			abiBuyoutFound=1
			return
		end

		if abiname==abiBuying.name and abicount==abiBuying.count and abiBid==abiBuying.bid and abiBidTime<5 then
			abiBuyThisItem=abiloop
			abiBuyThisPrice=abiBid
			abiPopupShown=1
			AuctionFrame:SetAlpha(0.5)
			StaticPopup_Show("abiBidConfirm",abiCreatePriceStringIcons(abiBuyThisPrice,""))
			abiBuyoutFound=1
			return
		end

	end

	abiSearchingWhichPage=abiSearchingWhichPage+1
	abiSetForLookingAtNextPage=1
	abiDoingABuyout=1 --restarts the onupdate fire
end



StaticPopupDialogs["abiBuyoutConfirm"]={
	text="Buyout auction for :|n%s",
	button1="Accept",
	button2="Cancel",

	OnAccept = function(self)
		abiMyAuctionPlaced=1
		PlaceAuctionBid("list",abiBuyThisItem,abiBuyThisPrice)
	end,

	OnCancel = function(self)
		abiDoingABuyout=0
		abiDisplayTheItems()
	end,

	OnHide = function(self)
		abiPutTextBackToNormal()
		AuctionFrame:SetAlpha(1)
		abiHidePerUnitInfo()
		abiPopupShown=0
	end,

	showAlert = 1,
	timeout=0,
}



StaticPopupDialogs["abiBidConfirm"]={
	text="Bid on this auction for :|n%s",
	button1="Accept",
	button2="Cancel",

	OnAccept = function(self)
		PlaceAuctionBid("list",abiBuyThisItem,abiBuyThisPrice)
		abiImageName="This Item No Longer Available"	
		abiAHImage[abiBuyoutNumber]=abiImageName.."%0%0%0%0%0"
		abiPriceIndex[abiRealm][abiImageName]=abiNilLink.."%0%0%0%0%0:0%0:0%0:0%0:0%0%0:0%0:0%x%0000000001*1" -- record for 'This Item No Longer Available'
		abiCurrentAuctions[abiImageName]=abiNilLink.."%0%0%0%0%0:0%0:0%0:0%0:0%0%0:0%0:0%x%0000000001*1" -- record for 'This Item No Longer Available'
		abiDoingABuyout=0
		abiDisplayTheItems()
	end,

	OnCancel = function(self)
		abiDoingABuyout=0
		abiDisplayTheItems()
	end,

	OnHide = function(self)
		abiPutTextBackToNormal()
		AuctionFrame:SetAlpha(1)
		abiHidePerUnitInfo()
		abiPopupShown=0
	end,

	showAlert = 1,
	timeout=0,
}



StaticPopupDialogs["abiNoLongerInAH"]={
	text="Item No Longer in AH",
	button1="Accept",

	OnAccept = function(self)
		abiDoingABuyout=0
		abiDisplayTheItems()
		AuctionFrame:SetAlpha(1)
	end,

	OnHide = function(self)
		abiPutTextBackToNormal()
		abiPopupShown=0
		abiHidePerUnitInfo()
	end,
	showAlert = 1,
	timeout=0,
}



StaticPopupDialogs["abiCancelAuction"]={
	text="You really want to end this auction?",
	button1="Accept",
	button2="Cancel",

	OnAccept = function(self)
		abiDoTheCancel()
		AuctionFrame:SetAlpha(1)
		abiDisplayTheItems()
	end,

	OnCancel = function(self)
		AuctionFrame:SetAlpha(1)
		abiDisplayTheItems()
	end,

	OnHide = function(self)
		AuctionFrame:SetAlpha(1)
	end,
	showAlert = 1,
	timeout=0,
}



StaticPopupDialogs["abiWarning"]={
	text="Warning!|nBlizzard servers are returning a total|nnumber of auctions as :%s|n|nIt is recommended that you use the|npage-by-page scanning method.|n|nIt is possible the page-by-page scan may|n'freeze' for upto 30 seconds when there are server problems.",
	button1="Ok",

	OnAccept = function(self)
		abiHomeScreenFrame:SetAlpha(1)
		abiEnablePSButtons()
		abiCurrentMainButton:Enable()
		abiSelectWhichBidToUseButton:Enable()
		abiSelectScanTypeButton:Enable()
	end,

	showAlert = 1,
	timeout=0,
}



StaticPopupDialogs["abiSuggestDevZeroScan"]={
	text="It is over 1 week since a scan was done|nwith the Max Deviation set at 0|n|nIt is recommended that you done one soon.",
	button1="Close",

	OnAccept = function(self)

	end,
	OnHide = function(self)
		AuctionFrame:SetAlpha(1)
		abiCurrentMainButton:Enable()
	end,
	showAlert = 1,
	timeout=0,
}




function abiSuggestZeroScan()
	AuctionFrame:SetAlpha(0.5)
	StaticPopup_Show("abiSuggestDevZeroScan")

end



function abiDoTheCancel()
	local abiHasCancelled=0
	local temp
	_,abiTemporaryNumber=GetNumAuctionItems("owner")
	GetOwnerAuctionItems(0)
	_,_,_,_,_,temp=strsplit("%",abiBargains[abiBuyThisItem])
	temp=tonumber(temp)

	if abiTemporaryNumber>0 then

		for i=1,abiTemporaryNumber do
			abiTemp1,_,abiTemp2,_,_,_,_,_,_,abiTemp3,_,_,_,_,_,_=GetAuctionItemInfo("owner",i)
			abiAuctionName,abiAuctionCount,abiAuctionBuyout=strsplit("%",abiMyAuctions[temp])
			abiAuctionCount=tonumber(abiAuctionCount)
			abiAuctionBuyout=tonumber(abiAuctionBuyout)

			if abiHasCancelled==0 and abiAuctionName==abiTemp1 and abiAuctionCount==abiTemp2 and abiAuctionBuyout==abiTemp3 then
				-- do the cancelling here
				CancelAuction(i)
				abiHasBeenCancelled=1
				abiBargains[abiBuyThisItem]="This Item No Longer Available%0%0%0%0%0"
			end
		end
	end			 	

end



function abiHidePerUnitInfo()
	abiUPF11:Hide()
	abiUPF12:Hide()
	abiUPF13:Hide()
	abiUPF14:Hide()
	abiUPF15:Hide()
	abiUPF22:Hide()
	abiUPF23:Hide()
	abiUPF24:Hide()
	abiUPF25:Hide()
end



function abiPriceChanging(passed,button)
	local abitemp

	if _G["abiFS"..passed.."1"]:GetText()=="empty" or
	_G["abiFS"..passed.."1"]:GetText()=="This Item No Longer Available" or
	abiPopupShown==1 or
	abiDisplayingFiveAuctions>0 then
		return
	end	

	if abiLastSearch~="Undercuts" then

		_,abiBuyoutNumber=strsplit("%",abiBargains[passed+abiTableOffset])
		abiBuyoutNumber=tonumber(abiBuyoutNumber)
		-- Get info from abiAHImage File
		abiImageName,_,_,_,_,_=abiDecodeImage(abiAHImage[abiBuyoutNumber])
	else
		_,_,_,_,_,abitemp=strsplit("%",abiBargains[passed+abiTableOffset])
		abitemp=tonumber(abitemp)
		abiImageName,_,_=strsplit("%",abiMyAuctions[abitemp])
	end

	if button=="LeftButton" then

		if IsShiftKeyDown()==true then
			abiImageName=abiShortenName(abiImageName)
		end

		--Put the item name into the BrowseName field of main AH window
		BrowseName:SetText(abiImageName)

		-- Now put it into search field of Adjusting screen
		abiAdjBrowseName:SetText(abiImageName)

		if (IsAddOnLoaded("Auctionator")) then
			Atr_Search_Box:SetText(abiImageName)
		end

		if abiBidTime==5 then
			return
		end

		local abiCanDoSearchQuery,_=CanSendAuctionQuery("list")

		while abiCanDoSearchQuery~=true do
			HowmanySecondsDelay(1) -- just prevents hammering the CanSendAuctionQuery
			abiCanDoSearchQuery,_=CanSendAuctionQuery("list")
		end

		if abiShowingFive==2 then
			abiBestFiveButtonPressed=passed
			abiDisplayFivePage=0
			abiDisplayingFiveAuctions=1
			abiFiveAuctions=table.wipe(abiFiveAuctions)
			QueryAuctionItems(abiImageName,0,0,0,0,0,abiDisplayFivePage)
		end
		return
	end

	-- gets here if the right-button clicked - force the price

	if abiLastSearch=="Undercuts" then
		return
	end
	
	local t
	local t1,t2,t3,t4,t5,t6,t7,t8,t9,t10,t11,t12
	local abiUpDown=1
	_,abiImageNumber=strsplit("%",abiBargains[passed+abiTableOffset])
	abiImageNumber=tonumber(abiImageNumber)
	abiImageName,abiImageCount,abiImagePrice,_,_,_=abiDecodeImage(abiAHImage[abiImageNumber])
	t=math.floor(abiImagePrice/abiImageCount)

	if t<1 then
		t=1
	end

	if IsShiftKeyDown()==true then
		abiUpDown=-1
	end

	if abiCurrent==0 then
		t1,t2,t3,t4,t5,t6,t7,t8,t9,abiTimeStamp,t11,t12,t10=abiDecodeIndex(abiPriceIndex[abiRealm][abiImageName])

		abiDecodePriceHistory(t10)
		abiUpdatePriceHistory(t,abiUpDown)
		t10=abiEncodePriceHistory()				
		abiPriceIndex[abiRealm][abiImageName]=t1.."%"..tostring(t2).."%"..tostring(t3).."%"..tostring(t4).."%"..tostring(t5).."%"..tostring(t6).."%"..tostring(t7).."%"..t8.."%"..t9.."%"..abiTimeStamp.."%"..t11.."%"..t12.."%x%"..t10
	else
		t1,t2,t3,t4,t5,t6,t7,t8,t9,_,t11,t12,t10=abiDecodeIndex(abiCurrentAuctions[abiImageName])

		abiDecodePriceHistory(t10)
		abiUpdatePriceHistory(t,abiUpDown)
		t10=abiEncodePriceHistory()				
		abiCurrentAuctions[abiImageName]=t1.."%"..tostring(t2).."%"..tostring(t3).."%"..tostring(t4).."%"..tostring(t5).."%"..tostring(t6).."%"..tostring(t7).."%"..t8.."%"..t9.."%x%"..t11.."%"..t12.."%x%"..t10
	end
	abiDisplayTheItems()
	abiDisplayExtraInformation(passed,0)

end



function abiFindTheFiveAuctions()

	if abiLastSearch=="Undercuts" then
		return
	end

-- first page of 'itemname' is loaded - read all items into abiFiveAuctions, then get next page if needed
	local abiDuration
	local b
	local abiUnitCost

	abiDisplayingFiveAuctions=0 -- stop the update firing
	b,_=GetNumAuctionItems("list")

	if b==0 then
		abiDisplayingFiveAuctions=2
		abiShowFiveAuctions()
		return
	end

	for abiloop=1,b do
		abiname,_,abicount,_,_,_,_,abiminBid,abiminIncrement,abibuyoutPrice,abibidAmount=GetAuctionItemInfo("list",abiloop)

		if abibidAmount~=0 then
			abiminBid=abibidAmount
		end

		if abibuyoutPrice==0 then
			abiUnitCost=math.floor(abiminBid/abicount)
		else
			abiUnitCost=math.floor(abibuyoutPrice/abicount)
		end

		abiDuration=GetAuctionItemTimeLeft("list",abiloop)

		if string.sub(abiname,1,#abiImageName)==abiImageName then
			abiFiveAuctions[#abiFiveAuctions+1]=abiMakeFullPrice(abiUnitCost).."%"..abiname.."%"..abiminBid.."%"..abibuyoutPrice.."%"..abicount.."%"..abiDuration
		end

	end

	if b<50 then
		abiShowFiveAuctions()
		abiDisplayingFiveAuctions=2
		return
	end

	abiDisplayFivePage=abiDisplayFivePage+1
	abiSetForLookingAtNextPage=1
	abiDisplayingFiveAuctions=1 --restarts the onupdate fire
end



function abiShowFiveAuctions()
	local index=0
	if abiBestFiveButtonPressed>7 then
		abiFiveBestFrame:SetPoint("TOPLEFT","abiDataFrame","TOPLEFT",70,-20)
	else
		abiFiveBestFrame:SetPoint("TOPLEFT","abiDataFrame","TOPLEFT",70,-175)
		index=6
	end

	abiFiveBestFrame:Show()
	for abiloop=index+1,index+7 do
		_G["abiFS"..abiloop.."1"]:Hide()
		_G["abiFS"..abiloop.."2"]:Hide()
		_G["abiFS"..abiloop.."3"]:Hide()
		_G["abiFS"..abiloop.."4"]:Hide()
		_G["abiFS"..abiloop.."5"]:Hide()
	end

	local abinumber=#abiFiveAuctions
	local abiName,abiUnit,abiBuy,abiBid,abiTime,abiCount

	table.sort(abiFiveAuctions,abiLowHigh)

	abiBargainsHelpFrame:SetText("|cffffffff"..abinumber.." matching auctions")

	if abinumber>5 then
		abinumber=5
	end

	abiDisplayHeader1:Show()
	abiDisplayHeader2:Show()
	abiDisplayHeader3:Show()
	abiDisplayHeader4:Show()
	abiDisplayHeader5:Show()

	for abiloop=1,5 do
		_G["abiDisplayDur"..abiloop]:Hide()
		_G["abiDisplayName"..abiloop]:Hide()
		_G["abiDisplayBid"..abiloop]:Hide()
		_G["abiDisplayBuy"..abiloop]:Hide()
		_G["abiDisplayUnit"..abiloop]:Hide()
	end

	for abiloop=1,abinumber do

		abiUnit,abiName,abiBid,abiBuy,abiCount,abiTime=strsplit("%",abiFiveAuctions[abiloop])
		abiBuy=tonumber(abiBuy)
		abiBid=tonumber(abiBid)
		abiCount=tonumber(abiCount)
		abiTime=tonumber(abiTime)

		_G["abiDisplayDur"..abiloop]:SetText(abiDisplayDurTable[abiTime])
		_G["abiDisplayName"..abiloop]:SetText(abiCount.." x "..abiName)

		AbigailMoneyFrame_Update(_G["abiDisplayBid"..abiloop],abiBid,0,"|cffffffff")
		AbigailMoneyFrame_Update(_G["abiDisplayBuy"..abiloop],abiBuy,0,"|cffffffff")
		AbigailMoneyFrame_Update(_G["abiDisplayUnit"..abiloop],abiUnit,0,"|cffffffff")

		_G["abiDisplayDur"..abiloop]:Show()
		_G["abiDisplayName"..abiloop]:Show()
		_G["abiDisplayBid"..abiloop]:Show()
		_G["abiDisplayBuy"..abiloop]:Show()
		_G["abiDisplayUnit"..abiloop]:Show()
	end

	abiFadeBargains(0.5)

end



function abiFadeBargains(passed)

	for abiloop=1,13 do
		_G["abiFS"..abiloop.."2"]:SetAlpha(passed)
		_G["abiFS"..abiloop.."3"]:SetAlpha(passed)
		_G["abiFS"..abiloop.."4"]:SetAlpha(passed)
		_G["abiFS"..abiloop.."5"]:SetAlpha(passed)
		_G["abiMessageFrame"..abiloop]:SetAlpha(passed)
	end

end



-- this function used to reverse sort the table abiBargains, so the greatest profit comes first
function abiHighLow(a,b)
	return a>b
end



function abiLowHigh(a,b)
	return b>a
end

 

function abiHomeScreenFrameUpdate(self,elapsed)

	local abiTime1
	local abiTime2
	local abiTimeLeft
	local temp
	local abiHowManyTotal,temp
	_,abiHowManyTotal=GetNumAuctionItems("list")

	if abiGetNextSlowPage==1 then

		temp,_=CanSendAuctionQuery("list")
		if temp==true then
			abiOptionsHelpFrame:SetText("|cffffffff".."Scanning Page : "..abiScanSlowPage.." / "..abitotalpages)
			abiGetNextSlowPage=0
			abiHomeScreenFrame:RegisterEvent("AUCTION_ITEM_LIST_UPDATE")
			QueryAuctionItems("",0,0,0,0,0,abiScanSlowPage)
		end
		return
	end	

	-- note - 901 is seconds in 15min 01secs, delay between allowing complete read of AH

	if abiTesting==0 then
		abiTimeLeft=901-(time()-abiPresets[abiWhichPreset][1])
	else
		abiTimeLeft=61-(time()-abiPresets[abiWhichPreset][1])
	end

	if abiScanType==2 then
		abiCreateSnapShotButton:SetText("|cffe0e000".."Take Snapshot")
		if abiDoingASlowScan==0 then
			abiCreateSnapShotButton:Enable()
		end

		return
	end

	if (abiTimeLeft<0 and abiCanTakeSnapShot==0) then

		abiCreateSnapShotButton:SetText("|cffe0e000".."Take Snapshot")

		if abiDoingASlowScan==0 then
			abiCreateSnapShotButton:Enable()
		end

		abiCanTakeSnapShot=1
		return
	end

	if abiTimeLeft>0 then	
		abiTime1=math.floor(abiTimeLeft/60) --abiTime1=Mins
		abiTime2=abiTimeLeft-(abiTime1*60) -- Seconds

		if abiTime2<10 then
			abiCreateSnapShotButton:SetText("Next Scan "..abiTime1..":0"..abiTime2)
		else
			abiCreateSnapShotButton:SetText("Next Scan "..abiTime1..":"..abiTime2)
		end

		abiCreateSnapShotButton:Disable()
	end

end



function abiDataFrameUpdate(self,elapsed)
	abiCanDoSearchQuery,_=CanSendAuctionQuery("list")

	if abiSetForLookingAtNextPage==1 and abiCanDoSearchQuery==1 and abiDisplayingFiveAuctions==0 then

		abiSetForLookingAtNextPage=0
		QueryAuctionItems(abiBuying.name,0,0,0,0,0,abiSearchingWhichPage)
	end

	if abiSetForLookingAtNextPage==1 and abiCanDoSearchQuery==1 and abiDisplayingFiveAuctions==1 then

		abiSetForLookingAtNextPage=0
		QueryAuctionItems(abiImageName,0,0,0,0,0,abiDisplayFivePage)
	end

end



function abiGetMyAuctions()
	local abiMyNumAuctions
	local abiTemporaryNumber
	local abiTemp1
	local abiTemp2
	local abiTemp3
	_,abiTemporaryNumber=GetNumAuctionItems("owner")
	abiMyAuctions=table.wipe(abiMyAuctions)
	GetOwnerAuctionItems(0)

	if abiTemporaryNumber>0 then

		for i=1,abiTemporaryNumber do
			abiTemp1,_,abiTemp2,_,_,_,_,_,_,abiTemp3,_,_,_,_,_,_=GetAuctionItemInfo("owner",i)
			-- name, count, buyout

			if abiTemp1==nil then
				abiTemp1="error"
			end

			abiMyAuctions[#abiMyAuctions+1]=abiTemp1.."%"..abiTemp2.."%"..abiTemp3
		end
	end
end



function abiGetMyBids()
	local abiMyNumBids
	local abiTemporaryNumber
	local abiTemp1
	local abiTemp2
	local abiTemp3
	_,abiTemporaryNumber=GetNumAuctionItems("bidder")

	abiMyBids=table.wipe(abiMyBids)
	GetBidderAuctionItems(0)

	if abiTemporaryNumber>0 then

		for i=1,abiTemporaryNumber do
			abiTemp1,_,abiTemp2,_,_,_,_,_,_,_,abiTemp3,_,_,_,_,_=GetAuctionItemInfo("bidder",i)
			-- name, count, bidamount

			if abiTemp1==nil then
				abiTemp1="error"
			end

			abiMyBids[#abiMyBids+1]=abiTemp1.."%"..abiTemp2.."%"..abiTemp3
		end
	end
end



function DoTheRegistering()
	abiHomeScreenFrame:RegisterEvent("AUCTION_ITEM_LIST_UPDATE")
	abiHomeScreenFrame:RegisterEvent("AUCTION_HOUSE_SHOW")
	abiHomeScreenFrame:RegisterEvent("AUCTION_HOUSE_CLOSED")
	abiHomeScreenFrame:RegisterEvent("CHAT_MSG_SYSTEM")
	abiHomeScreenFrame:RegisterEvent("UI_ERROR_MESSAGE")
	abiHomeScreenFrame:RegisterEvent("ADDON_LOADED")
	abiHomeScreenFrame:RegisterEvent("MODIFIER_STATE_CHANGED")
end



function abiHomeScreenFrame_OnEvent(frame,event,arg1,arg2,...)
	if event=="ADDON_LOADED" and arg1=="Abigail" then

		if abiPLV==nil then
			abiPLV={}
		end

		if abiPLV[abiRealm]==nil then
			abiPLV[abiRealm]={}
		end
		
		if abiPLV[abiRealm][1]==nil then
			abiPLV[abiRealm][1]=abiPresets[1][26] -- used to be money spent
			abiPresets[1][26]=false
			abiPresets[2][26]=false
			abiPresets[3][26]=false
			abiPresets[4][26]=false
			abiPresets[5][26]=false
			abiPresets[6][26]=false
		end
		
		if abiPLV[abiRealm][2]==nil then
			abiPLV[abiRealm][2]=abiPresets[1][27] -- used to be money earned
			abiPresets[1][27]=false
			abiPresets[2][27]=false
			abiPresets[3][27]=false
			abiPresets[4][27]=false
			abiPresets[5][27]=false
			abiPresets[6][27]=false
		end

		BattlePetTooltip:SetScript("OnShow",pettoolshow)
		BattlePetTooltip:SetScript("OnHide",pettoolhide)
		abiFiveBestFrame:Hide()
		abiExtraFrame:Hide()

		-- Hook the Blizzard functions to get the stack size of object mouse is over

		--This Hook Does Standard Bag Items
		hooksecurefunc (GameTooltip, "SetBagItem",
		function(tip, whichbag, whichslot)
			_, abiStackSize,_,_,_,_,abiTempName = GetContainerItemInfo(whichbag, whichslot)
			abiPresets[abiWhichPreset][24]=abiStackSize

			if abiPresets[abiWhichPreset][24]~=nil then
				abiTempName=abiDecodeItemLink(abiTempName)
			end

		end
		);


		--This Hook Does The Bank Slots and Bags
		hooksecurefunc (GameTooltip, "SetInventoryItem",
		function (tip, whichunit, whichslot)
			abiStackSize=GetInventoryItemCount(whichunit,whichslot)
			abiTempName=GetInventoryItemLink(whichunit,whichslot)

			if abiTempName~=nil then
				abiTempName=abiDecodeItemLink(abiTempName)
				abiPresets[abiWhichPreset][24]=abiStackSize
			end

		end
		);

		--This Hook Does The AH Browse and Bids Screen
		hooksecurefunc (GameTooltip, "SetAuctionItem",
		function (tip, whichtype, whichindex)
			abiTempName, _, abiStackSize = GetAuctionItemInfo(whichtype, whichindex)
			abiPresets[abiWhichPreset][24]=abiStackSize			
		end
		);

		abiHomeScreenFrame:UnregisterEvent("ADDON_LOADED")


		-- Try to hook the Mail Routines to get when user is clicking on an item to take
		-- Looking for items returned by AH as unsold, items bought through the AH
		-- and cash from sold items.

		-- Looking for Auction Won, Auction expired, Auction successful

		abiHook4=InboxFrame_OnClick
		function InboxFrame_OnClick(self,index,...)

	--	abiHook4=OpenMailAttachment_OnClick
	--	function OpenMailAttachment_OnClick(self,index,...)

			abiRealm=GetRealmName()..abiMyFaction

			local t1,t2,t3,t4,t5,t6,t7,abiRatio,t8,t9,t10,t11
			local Rat1,Rat2
			local abiBid,abiBuyout,abiAmount,abiVendorPrice,abiDeposit,abiConsignment

			_,_,_,abiSubject,_,_,_,_,abiWasRead=GetInboxHeaderInfo(index)
			abiItemName,_,abiCount=GetInboxItem(index)

			if string.sub(abiSubject,1,15)=="Auction expired" and abiWasRead==false then
				abiItemName=GetInboxItem(index)
				abiItemLink=GetInboxItemLink(index)

				_,_,_,_,_,_,_,_,_,_,abiVendorPrice=GetItemInfo(abiItemLink)

				if abiVendorPrice==nil then
					abiVendorPrice=1
				end

				if abiVendorPrice==0 then
					abiVendorPrice=1
				end

				if abiItemLink==nil then
					abiItemLink=abiNilLink
				end

				if abiDecodeItemLink(abiItemLink)=="Pet Cage" then
					abiItemLink=abiNilLink
				end

				if abiPriceIndex[abiRealm][abiItemName]~=nil then
					t1,t2,t3,t4,t5,t6,t7,abiRatio,t8,abiTimeStamp,t10,t11,t9=abiDecodeIndex(abiPriceIndex[abiRealm][abiItemName])
					Rat1,Rat2=abiDecodeRatio(abiRatio)
					Rat2=Rat2+1
					abiRatio=tostring(Rat1)..":"..tostring(Rat2)

					if t1==abiNilLink then
						t1=abiItemLink
					end

					abiPriceIndex[abiRealm][abiItemName]=t1.."%"..t2.."%"..t3.."%"..t4.."%"..t5.."%"..t6.."%"..t7.."%"..abiRatio.."%"..t8.."%"..abiTimeStamp.."%"..t10.."%"..t11.."%x%"..t9
				else
					abiPriceIndex[abiRealm][abiItemName]=abiItemLink.."%0%0%0%0%0:0%0:0%0:1%0:0%"..time().."%0:0%0:0%x%"..abiMakeFullPrice(abiVendorPrice).."*1"
				end

				if abiCurrentAuctions[abiItemName]~=nil then
					t1,t2,t3,t4,t5,t6,t7,abiRatio,t8,_,t10,t11,t9=abiDecodeIndex(abiCurrentAuctions[abiItemName])
					Rat1,Rat2=abiDecodeRatio(abiRatio)
					Rat2=Rat2+1
					abiRatio=tostring(Rat1)..":"..tostring(Rat2)

					if t1==abiNilLink then
						t1=abiItemLink
					end

					abiCurrentAuctions[abiItemName]=t1.."%"..t2.."%"..t3.."%"..t4.."%"..t5.."%"..t6.."%"..t7.."%"..abiRatio.."%"..t8.."%x%"..t10.."%"..t11.."%x%"..t9
				else
					abiCurrentAuctions[abiItemName]=abiItemLink.."%0%0%0%0%0:0%0:0%0:1%0:0%x%0:0%0:0%x%"..abiMakeFullPrice(abiVendorPrice).."*1"

				end

			end

			if string.sub(abiSubject,1,18)=="Auction successful" and abiWasRead==false then

				_,abiItemName,_,abiBid,abiBuyout,abiDeposit,abiConsignment=GetInboxInvoiceInfo(index)

				_,abiItemLink=GetItemInfo(abiItemName)
				if abiItemName=="Pet Cage" then
					abiItemName=string.sub(abiSubject,21)
					abiItemLink=abiNilLink
				end

				if abiItemLink==nil then
					abiItemLink=abiNilLink
				end

				if abiBuyout==0 or abiBid<abiBuyout then
					abiAmount=abiBid
				else
					abiAmount=abiBuyout
				end

				abiPLV[abiRealm][1]=abiPLV[abiRealm][1]+abiAmount-abiConsignment+abiDeposit

				-- get the amount / stack size
				abiAmount=math.floor(abiAmount/abiCalculateStackSize(abiSubject))

				if abiAmount<1 then
					abiAmount=1
				end

				abiVendorPrice=math.floor(abiAmount/2)

				if abiVendorPrice<1 then
					abiVendorPrice=1
				end

				if abiPriceIndex[abiRealm][abiItemName]~=nil then

					t1,t2,t3,abiShigh1,abiSlow1,abiRsold1,t7,abiRatio1,t8,abiTimeStamp,t10,t11,t9=abiDecodeIndex(abiPriceIndex[abiRealm][abiItemName])

					Rat1,Rat2=abiDecodeRatio(abiRatio1)
					Rat1=Rat1+1
					Rat2=Rat2+1

					-- this next bit needed incase of a successful sell of an item we have not recorded as been auctioned
					if Rat1>Rat2 then
						Rat2=Rat1
					end

					if abiAmount>abiShigh1 then
						abiShigh1=abiAmount
					end

					if abiAmount<abiSlow1 or abiSlow1==0 then
						abiSlow1=abiAmount
					end

					abiRsold1=tostring(abiAmount)..":"..tostring(time())
					abiRatio1=tostring(Rat1)..":"..tostring(Rat2)
					abiPriceIndex[abiRealm][abiItemName]=t1.."%"..t2.."%"..t3.."%"..abiShigh1.."%"..abiSlow1.."%"..abiRsold1.."%"..t7.."%"..abiRatio1.."%"..t8.."%"..abiTimeStamp.."%"..t10.."%"..t11.."%x%"..t9
				else
					abiPriceIndex[abiRealm][abiItemName]=abiItemLink.."%0%0%"..abiAmount.."%"..abiAmount.."%"..abiAmount..":"..time().."%0:0%1:1%0:0%"..time().."%0:0%0:0%x%"..abiMakeFullPrice(abiVendorPrice).."*1"
				end

				if abiCurrentAuctions[abiItemName]~=nil then

					t1,t2,t3,abiShigh1,abiSlow1,abiRsold1,t7,abiRatio1,t8,_,t10,t11,t9=abiDecodeIndex(abiCurrentAuctions[abiItemName])

					Rat1,Rat2=abiDecodeRatio(abiRatio1)
					Rat1=Rat1+1
					Rat2=Rat2+1

					-- this next bit needed incase of a successful sell of an item we have not recorded as been auctioned
					if Rat1>Rat2 then
						Rat2=Rat1
					end

					if abiAmount>abiShigh1 then
						abiShigh1=abiAmount
					end

					if abiAmount<abiSlow1 or abiSlow1==0 then
						abiSlow1=abiAmount
					end

					abiRsold1=tostring(abiAmount)..":"..tostring(time())
					abiRatio1=tostring(Rat1)..":"..tostring(Rat2)
					abiCurrentAuctions[abiItemName]=t1.."%"..t2.."%"..t3.."%"..abiShigh1.."%"..abiSlow1.."%"..abiRsold1.."%"..t7.."%"..abiRatio1.."%"..t8.."%x%"..t10.."%"..t11.."%x%"..t9
				else
					abiCurrentAuctions[abiItemName]=abiItemLink.."%0%0%"..abiAmount.."%"..abiAmount.."%"..abiAmount..":"..time().."%0:0%1:1%0:0%x%0:0%0:0%x%"..abiMakeFullPrice(abiVendorPrice).."*1"
				end

			end

			if string.sub(abiSubject,1,11)=="Auction won" and abiWasRead==false then

				_,abiItemName,_,abiBid,abiBuyout=GetInboxInvoiceInfo(index)
				abiItemLink=nil

				if abiItemName=="Pet Cage" then
					abiItemName=string.sub(abiSubject,14)
				else
					abiItemLink=GetInboxItemLink(index)
				end

				if abiItemLink==nil then
					abiItemLink=abiNilLink
				end

				if abiBuyout==0 or abiBid<abiBuyout then
					abiAmount=abiBid
				else
					abiAmount=abiBuyout
				end
				-- add amount spent 
					abiPLV[abiRealm][2]=abiPLV[abiRealm][2]+abiAmount

				-- get the amount / stack size
				abiAmount=math.floor(abiAmount/abiCalculateStackSize(abiSubject))

				if abiAmount<1 then
					abiAmount=1
				end

				if abiPriceIndex[abiRealm][abiItemName]~=nil then
					t1,abiBhigh1,abiBlow1,t4,t5,t6,t7,abiRatio1,t8,abiTimeStamp,t10,t11,t9=abiDecodeIndex(abiPriceIndex[abiRealm][abiItemName])

					if abiBhigh1<abiAmount then
						abiBhigh1=abiAmount
					end

					if abiBlow1>abiAmount or abiBlow1==0 then
						abiBlow1=abiAmount
					end

					t7=tostring(abiAmount)..":"..tostring(time())
					abiPriceIndex[abiRealm][abiItemName]=t1.."%"..abiBhigh1.."%"..abiBlow1.."%"..t4.."%"..t5.."%"..t6.."%"..t7.."%"..abiRatio1.."%"..t8.."%"..abiTimeStamp.."%"..t10.."%"..t11.."%x%"..t9
				else
					abiPriceIndex[abiRealm][abiItemName]=abiItemLink.."%"..abiAmount.."%"..abiAmount.."%0%0%0:0%"..abiAmount..":"..time().."%0:0%0:0%"..time().."%0:0%0:0%x%"..abiMakeFullPrice(abiAmount).."*1"
				end

				if abiCurrentAuctions[abiItemName]~=nil then
					t1,abiBhigh1,abiBlow1,t4,t5,t6,t7,abiRatio1,t8,_,t10,t11,t9=abiDecodeIndex(abiCurrentAuctions[abiItemName])

					if abiBhigh1<abiAmount then
						abiBhigh1=abiAmount
					end

					if abiBlow1>abiAmount or abiBlow1==0 then
						abiBlow1=abiAmount
					end

					t7=tostring(abiAmount)..":"..tostring(time())
					abiCurrentAuctions[abiItemName]=t1.."%"..abiBhigh1.."%"..abiBlow1.."%"..t4.."%"..t5.."%"..t6.."%"..t7.."%"..abiRatio1.."%"..t8.."%x%"..t10.."%"..t11.."%x%"..t9
				else
					abiCurrentAuctions[abiItemName]=abiItemLink.."%"..abiAmount.."%"..abiAmount.."%0%0%0:0%"..abiAmount..":"..time().."%0:0%0:0%x%0:0%0:0%x%"..abiMakeFullPrice(abiAmount).."*1"
				end

			end

			return abiHook4(self,index,...)
		end


		abiRealm=GetRealmName()..abiMyFaction

		if abiShoppingList==nil then
			abiShoppingList={}
		end

		if abiShoppingList[abiRealm]==nil then
			abiShoppingList[abiRealm]={}
		end

		print("Abigail 2.40 Loaded")

		abiSelfClean()

		print("Abigail Self-Cleaning process completed.")

	end


	if event=="AUCTION_ITEM_LIST_UPDATE" then
		if abiDoingASlowScan==1 then

			abiHomeScreenFrame:UnregisterEvent("AUCTION_ITEM_LIST_UPDATE")
			abibatch,abitotal=GetNumAuctionItems("list")
			abitotalpages=math.floor(abitotal/50)+1

			if abiLastSlowPage~=abiScanSlowPage then
				abiLastSlowPage=abiSlowScanPage

				for abiloop=1,abibatch do

					abiname,_,abicount,_,_,_,_,abiminBid,abiminIncrement,abibuyoutPrice,abibidAmount=GetAuctionItemInfo("list",abiloop)
					abiDuration=GetAuctionItemTimeLeft("list",abiloop)

					if (abicount~=nil) and (abibuyoutPrice~=nil) and (abibuyoutPrice~=0)then
						abiItemLink=GetAuctionItemLink("list",abiloop)
						abiBid=abiminBid

						if abibidAmount>0 then
							abiBid=abibidAmount+abiminIncrement
						end

						if CheckIfOneOfMyAuctions(abiname,abicount,abibuyoutPrice)==0 and CheckIfOneOfMyBids(abiname,abicount,abibidAmount)==0 and abiItemLink~=nil then
							abiAHImage[#abiAHImage+1]=abiname.."%"..abicount.."%"..abibuyoutPrice.."%"..abiItemLink.."%"..abiDuration.."%"..abiBid

							if abiSB[abiname]==nil then
								abiSB[abiname]=0
							end

							abiSB[abiname]=abiSB[abiname]+1

						end

					end
				end
			end

			if (abiScanSlowPage*50)>abitotal then
				abiGetNextSlowPage=0
				abiDoingASlowScan=0


				abiBargainSearchButton:Enable()
				abiCreateSnapShotButton:Enable()
				abiSelectScanTypeButton:Enable()
				abiSelectWhichBidToUseButton:Enable()
				abiCurrentMainButton:Enable()
				abiEnablePSButtons()
				abiAddSnapShotToPriceIndex()
				abiOptionsFrameHelp(3)

				return
			end
			abiScanSlowPage=abiScanSlowPage+1
			abiGetNextSlowPage=1

			return
		end


		if abiDisplayingFiveAuctions==1 then
			abiFindTheFiveAuctions()
			return
		end

		if abiAreWeReadingTheAH==1 then
			abiHomeScreenFrame:UnregisterEvent("AUCTION_ITEM_LIST_UPDATE")

			if abiTesting==0 then
				_,abiHowManyAuctions=GetNumAuctionItems("list")
			else
				abiHowManyAuctions=50
			end

			if abiHowManyAuctions>150000 then
				abiHomeScreenFrame:SetAlpha(0.3)
				StaticPopup_Show("abiWarning",tostring(abiHowManyAuctions))
				abiHowManyAuctions=abiMAX_ALLOWED_AUCTIONS
				return
			end

			if abiHowManyAuctions>abiMAX_ALLOWED_AUCTIONS and abiScanType~=3 then
				abiHowManyAuctions=abiMAX_ALLOWED_AUCTIONS
			end

			abiReadTheAuctionHouse()
			return
		end

		if abiDoingABuyout==1 then
			abiLookForTheItem()
		end

	end

	if event=="AUCTION_HOUSE_SHOW" then
		if abiAuctionHouseShown==0 then
			abiInitialise()
			abiTabText=table.wipe(abiTabText)

			abiHomeScreenFrame:SetParent"AuctionFrame"
			abiDataFrame:SetParent"AuctionFrame"
			abiShoppingFrame:SetParent"AuctionFrame"
			abiSellingFrame:SetParent"AuctionFrame"
			abiAdjustingFrame:SetParent"AuctionFrame"
			abiDeletingFrame:SetParent"AuctionFrame"

			abiProfitLossFrame:SetParent"AuctionFrame"
			abiProfitLossFrame:SetPoint("TOPLEFT","AuctionFrame","TOPLEFT",70,12)

			abiOptionsTabNum=AuctionFrame.numTabs+1
			abiBargainsTabNum=abiOptionsTabNum+1
			abiShoppingTabNum=abiBargainsTabNum+1
			abiSellingTabNum=abiShoppingTabNum+1
			abiAdjustingTabNum=abiSellingTabNum+1
			abiDeleteTabNum=abiAdjustingTabNum+1

			abiMakeTheTab("Main",abiOptionsTabNum,"Main Options")
			abiMakeTheTab("Deals",abiBargainsTabNum,"Bargains / Bids")
			abiMakeTheTab("Shop",abiShoppingTabNum,"Shopping List")
			abiMakeTheTab("Sell",abiSellingTabNum,"Sell Your Items")
			abiMakeTheTab("Adjust",abiAdjustingTabNum,"Adjust Pricing Records")
			abiMakeTheTab("Delete",abiDeleteTabNum,"Delete Unwanted Records")

			abiMakeTheHeaders()
			hooksecurefunc("AuctionFrameTab_OnClick",abiFrameTab_OnClick)

			-- Hook the Auctionator functions

			if (IsAddOnLoaded("Auctionator")) then
				abiHook5=Atr_ClearBrowseListings

				function Atr_ClearBrowseListings(self,index,...)
					local b,t=GetNumAuctionItems("list")
					abiAuctionatorScanned()
					return abiHook5(self,index,...)
				end

				Atr_FullScanStartButton:HookScript("OnClick",abiAuctionatorStarted)
			end
		end

		abiShowProfitLossFrames()
		abiAuctionHouseShown=1
		abiPresetName:SetText(abiPresets[abiWhichPreset][28])
		abiSetSlidersAndBoxes()
	end

	if event=="AUCTION_HOUSE_CLOSED" then
		abiPresets[abiWhichPreset][2]=floor(MinSpendSlider:GetValue())
		abiPresets[abiWhichPreset][3]=floor(MaxSpendSlider:GetValue())
		abiPresets[abiWhichPreset][4]=floor(ProfitMarginSlider:GetValue())
		abiPresets[abiWhichPreset][5]=floor(CashProfitSlider:GetValue())
		abiPresets[abiWhichPreset][6]=floor(DeviationSlider:GetValue())
		abiPresets[abiWhichPreset][25]=floor(MaxSameSlider:GetValue())
		abiPresets[abiWhichPreset][7]=abiTooltipCB1:GetChecked()
		abiPresets[abiWhichPreset][8]=abiTooltipCB2:GetChecked()
		abiPresets[abiWhichPreset][9]=abiTooltipCB3:GetChecked()
		abiPresets[abiWhichPreset][10]=abiTooltipCB4:GetChecked()
		abiPresets[abiWhichPreset][11]=abiTooltipCB5:GetChecked()
		abiPresets[abiWhichPreset][12]=abiTooltipCB6:GetChecked()

		for abiloop=13,23 do
			abiPresets[abiWhichPreset][abiloop]=_G["abiTypeCheck"..(abiloop-12)]:GetChecked()

			if abiPresets[abiWhichPreset][abiloop]==nil then
				abiPresets[abiWhichPreset][abiloop]=false
			end

		end

		abiPresets[abiWhichPreset][24]=0
		abiPresets[abiWhichPreset][28]=abiPresetName:GetText()
		abiPresets[abiWhichPreset][29]=abiScanType
		abiPresets[abiWhichPreset][30]=abiBidTime
		abiPresets[abiWhichPreset][31]=abiCurrent
		
		abiScrollFrame1:SetVerticalScroll(0)
		abiOnTheButton=0
		abiProfitLossFrame:Hide()

		-- now close all bags
		ContainerFrame1:Hide()
		ContainerFrame2:Hide()
		ContainerFrame3:Hide()
		ContainerFrame4:Hide()
		ContainerFrame5:Hide()

	end

	if event=="CHAT_MSG_SYSTEM" and string.sub(arg1,1,18)=="You won an auction" and abiMyAuctionPlaced==1 then
		abiImageName,abiImageCount,abiImagePrice,abiItemLink,abiImageTime,abiImageBid=strsplit("%",abiAHImage[abiBuyoutNumber])
		abiImageName="This Item No Longer Available"	
		abiAHImage[abiBuyoutNumber]=abiImageName.."%0%0%0%0%0"
		abiPriceIndex[abiRealm][abiImageName]=abiNilLink.."%0%0%0%0%0:0%0:0%0:0%0:0%0%0:0%0:0%x%0000000001*1" -- record for This Item No Longer Available
		abiCurrentAuctions[abiImageName]=abiNilLink.."%0%0%0%0%0:0%0:0%0:0%0:0%0%0:0%0:0%x%0000000001*1" -- record for This Item No Longer Available
		abiDisplayTheItems()
		abiMyAuctionPlaced=0
	end

	if (event == "UI_ERROR_MESSAGE" and arg1) then

		if (arg1 == ERR_ITEM_NOT_FOUND or arg1 == ERR_NOT_ENOUGH_MONEY or arg1 == ERR_AUCTION_BID_OWN) and abiMyAuctionPlaced==1 then
			print(arg1)
			abiMyAuctionPlaced=0
		end

	end

	-- this event to show stack-size prices on tooltip when in AH sell item slot
	if event=="MODIFIER_STATE_CHANGED" and (arg1=="LSHIFT" or arg1=="RSHIFT") then
		local f,n,v
		f=GetMouseFocus()

		if f~=nil then

			n=f:GetName()

			if string.sub(n,1,9)=="abiButton" then
				v=string.sub(n,10)
				v=tonumber(v)
				abiMessageFrame_OnEnter(v,1)
				return
			end

			if n~="AuctionsItemButton" then
				return
			end

			n,_,abiStackSize=GetAuctionSellItemInfo()
			abiPresets[abiWhichPreset][24]=abiStackSize

			if arg2==0 then
				abiStackSize = 1
				abiPresets[abiWhichPreset][24]=1
			end

			if n~=nil then
				GameTooltip:SetAuctionSellItem()
			end
		end

	end

end



function abiAuctionatorScanned(self,index)

	if abiAuctionatorScanStarted==1 then
		print("Auctionator GETALL Scan data has been sent to Abigail 2.40")
		_,abiHowManyAuctions=GetNumAuctionItems("list")

		if abiHowManyAuctions>abiMAX_ALLOWED_AUCTIONS and abiScanType~=3 then
			abiHowManyAuctions=abiMAX_ALLOWED_AUCTIONS
		end

		abiGetMyAuctions()
		abiGetMyBids()
		abiAHImage=table.wipe(abiAHImage)
		abiReadTheAuctionHouse()
	end

	abiAuctionatorScanStarted=0
end



function abiAuctionatorStarted(self,index)
	abiAuctionatorScanStarted=1 -- so that pressing the Done button is only acted upon if the scan has been done first.
	abiPresets[1][1]=time()
	abiPresets[2][1]=time()
	abiPresets[3][1]=time()
	abiPresets[4][1]=time()
	abiPresets[5][1]=time()
	abiPresets[6][1]=time()
	abiCanTakeSnapShot=0
end



function abiMakeTheTab(name,tabIndex,abiTipText)
	-- Create the tab itself.
	local tab = CreateFrame("Button", "AuctionFrameTab" .. tabIndex, AuctionFrame, "AuctionTabTemplate");
	tab:SetID(tabIndex);
	tab:SetText(name);
	tab:SetPoint("TOPLEFT", "AuctionFrameTab" .. (tabIndex - 1), "TOPRIGHT", -8, 0);
	tab:SetWidth(72) -- Make sure the tabs don't go past the AH window incase Auctionator is loaded as well.
	-- Link it into the auction frame.
	PanelTemplates_DeselectTab(tab);
	PanelTemplates_SetNumTabs(AuctionFrame, tabIndex);
	abiTabText[tabIndex]=abiTipText
	_G["AuctionFrameTab"..tabIndex]:SetScript("OnEnter",abiShowLittleTip)
	_G["AuctionFrameTab"..tabIndex]:SetScript("OnLeave",abiHideLittleTip)

end



function abiShowLittleTip(self)
	index=self:GetID()
	CreateFrame("GameToolTip","abiTabTooltip",UIParent,"GameTooltipTemplate")
	abiTabTooltip:SetOwner(UIParent,"ANCHOR_NONE")
	abiTabTooltip:ClearLines()
	abiTabTooltip:AddLine("Abigail")
	abiTabTooltip:AddLine(abiTabText[index])
	abiTabTooltip:SetPoint("TOPLEFT","AuctionFrameTab"..index,"TOPLEFT",20,50)
	abiTabTooltip:Show()
end



function abiHideLittleTip()
	abiTabTooltip:Hide()
end



function abiOpenCloseBagsIfNeeded(i,lastscreen)

	if i==abiSellingTabNum and #abiAHImage~=0 then
		if abiAutoBagCheck:GetChecked()==true then

			for abiloop=1,5 do
				_G["ContainerFrame"..abiloop]:Hide()
			end

			for abiloop=0,4 do
				ToggleBag(abiloop)
			end
		end
	end

	if i~=abiSellingTabNum and lastscreen==abiSellingTabNum and #abiAHImage~=0 then
		if abiAutoBagCheck:GetChecked()==true then
			for abiloop=1,5 do
				_G["ContainerFrame"..abiloop]:Hide()
			end
		end
	end

end




function abiFrameTab_OnClick(self, index)
	abiPresets[abiWhichPreset][28]=abiPresetName:GetText()
	if abiDoingASlowScan==1 then
		index=abiOptionsTabNum
	else
		index=self:GetID()
	end


	abiOnTheButton=0
	abiNoBargainsFoundButton:Hide()
	abiShowingWhichBargainsString:Hide()
	abiSellingFrame:Hide()
	abiDataFrame:Hide()
	abiHomeScreenFrame:Hide()
	abiShoppingFrame:Hide()
	abiAdjustingFrame:Hide()
	abiDeletingFrame:Hide()

	abiHomeScreenFrame:UnregisterEvent("AUCTION_ITEM_LIST_UPDATE")

	abiOpenCloseBagsIfNeeded(index,abiLastScreen)

	if index~=abiBargainsTabNum then
		abiMyAuctionPlaced=0
		abiPutTextBackToNormal()
	end

	if index~=abiShoppingTabNum then

		abiNoSnapshotTakenButton:Hide()
		--abiGenerateButton:Enable()
		abiShoppingSearchButton:Enable()
	end

	if index<abiOptionsTabNum then
		return
	else
		AuctionFrameTopLeft:SetTexture("Interface\\AuctionFrame\\UI-AuctionFrame-Bid-TopLeft");
		AuctionFrameTop:SetTexture("Interface\\AuctionFrame\\UI-AuctionFrame-Auction-Top");
		AuctionFrameTopRight:SetTexture("Interface\\AuctionFrame\\UI-AuctionFrame-Auction-TopRight");
		AuctionFrameBotLeft:SetTexture("Interface\\AuctionFrame\\UI-AuctionFrame-Bid-BotLeft");
		AuctionFrameBotRight:SetTexture("Interface\\AuctionFrame\\UI-AuctionFrame-Bid-BotRight");
		AuctionFrameAuctions:Hide()
		AuctionFrameBrowse:Hide()
		AuctionFrameBid:Hide()
	end

	if index==abiOptionsTabNum then
		if abiFirstRun==0 and time()-abiLastZero>604800 and abiLastZero~=0 then -- number of seconds in a week
			abiSuggestZeroScan()
		end

		if abiFirstRun==0 then
			abiFirstRun=1
		end

		abiHomeScreenFrame:RegisterEvent("AUCTION_ITEM_LIST_UPDATE")
		local abiTemporaryNumber
		abiHomeScreenFrame:Show()
		abiPresetName:SetText(abiPresets[abiWhichPreset][28])
		abiHomeScreenFrame:SetPoint("TOPLEFT",AuctionFrame,"TOPLEFT",15,-68)
		abiTemporaryNumber=math.floor(GetMoney()/10000)
		MaxSpendSlider:SetMinMaxValues(0,abiTemporaryNumber)


		abiTemporaryNumber=#abiBargains

		if abiLastSearch=="Undercuts" then
			abiBargainsString:SetText("Undercuts Found : "..abiTemporaryNumber)
		end

		if abiLastSearch=="Bargains" or abiLastSearch=="Single Items" then
			abiBargainsString:SetText("Bargains Found : "..abiTemporaryNumber)
		end

		if abiLastSearch=="Bids" then
			abiBargainsString:SetText("Bids Found : "..abiTemporaryNumber)
		end

		abiGetMyAuctions()
		abiGetMyBids()

		if #abiAHImage==0 then
			abiOptionsFrameHelp(1)
		else
			abiOptionsFrameHelp(3)
		end

		abiShowProfitLossFrames()
		AuctionFrameMoneyFrame:Show()
		abiLastScreen=index
	end

	if index==abiBargainsTabNum then
		abiHomeScreenFrame:RegisterEvent("AUCTION_ITEM_LIST_UPDATE")

		if #abiBargains~=0 then

			abiDataFrame:Show()
			abiShowProfitLossFrames()
			abiDataFrame:SetPoint("TOPLEFT",AuctionFrame,"TOPLEFT",15,-68)
			abiShowTheBargains()

			if abiLastSearch=="Undercuts" then
				abiBargainsFrameHelp(2)
				abiExtraFrame:Hide()
			else
				abiBargainsFrameHelp(1)
				abiExtraFrame:Show()
			end
		else
			abiNoBargainsFoundButton:Show()
		end

		AuctionFrameMoneyFrame:Show()
			abiLastScreen=index
	end

	if index==abiShoppingTabNum then
		if #abiAHImage~=0 then
			abiShoppingFrame:Show()
			abiShoppingFrame:SetPoint("TOPLEFT",AuctionFrame,"TOPLEFT",15,-68)
			abiShowFrameHelp(6)
			abiAutoGenerate()
			abiCreateScrollList2()
		else
			abiNoSnapshotTakenButton:Show()
		end

		AuctionFrameMoneyFrame:Show()
		abiLastScreen=index
	end

	if index==abiSellingTabNum then

		if #abiAHImage~=0 then

			abiSellingFrame:Show()
			abiSellingFrame:SetPoint("TOPLEFT",AuctionFrame,"TOPLEFT",15,-68)
			abiSellHelp(1)

		else
			abiNoSnapshotTakenButton:Show()
		end

		AuctionFrameMoneyFrame:Show()
		abiLastScreen=index
	end

	if index==abiAdjustingTabNum then
		abiAdjustingFrame:Show()
		abiAdjustingFrame:SetPoint("TOPLEFT",AuctionFrame,"TOPLEFT",15,-68)
		abiSellHelp(1)

		AuctionFrameMoneyFrame:Show()
		abiAdjustSetup()
		abiLastScreen=index
	end

	if index==abiDeleteTabNum then
		abiDeletingFrame:Show()
		abiDeletingFrame:SetPoint("TOPLEFT",AuctionFrame,"TOPLEFT",15,-68)
		abiDeleteFrameHelp(1)
		abiGetScanHistorys()
		abiDisplayScanHistorys()
		AuctionFrameMoneyFrame:Show()
		abiLastScreen=index
	end

end



function abiInitialise() -- Auction House opened and event handler has called this routine
	local abiTemporaryNumber

	for abiLoop=1,31 do

		if abiPresets[abiWhichPreset][abiLoop]==nil then
			abiPresets[abiWhichPreset][abiLoop]=false
		end

	end

	MinSpendSlider:SetValue(abiPresets[abiWhichPreset][2])
	abiTemporaryNumber=math.floor(GetMoney()/10000)
	MaxSpendSlider:SetMinMaxValues(0,abiTemporaryNumber)

	if abiPresets[abiWhichPreset][3]>abiTemporaryNumber then
		abiPresets[abiWhichPreset][3]=abiTemporaryNumber
	end

	MaxSpendSlider:SetValue(abiPresets[abiWhichPreset][3])
	ProfitMarginSlider:SetValue(abiPresets[abiWhichPreset][4])
	CashProfitSlider:SetValue(abiPresets[abiWhichPreset][5])
	DeviationSlider:SetValue(abiPresets[abiWhichPreset][6])
	MaxSameSlider:SetValue(abiPresets[abiWhichPreset][25])

	--Setup the tooltip check buttons

	for abiLoop=1,6 do
		_G["abiTooltipCB"..abiLoop]:SetChecked(abiPresets[abiWhichPreset][abiLoop+6])
	end
	abiTooltipCB7:SetChecked(abiPresets[abiWhichPreset][26])


	--Setup item type check buttons
	for abiLoop=1,11 do
		_G["abiTypeCheck"..abiLoop]:SetChecked(abiPresets[abiWhichPreset][abiLoop+12])
	end

	abiCreatePriceHistoryFrames()
	abiCreateExtraBits()
	abiSellingMakeFrames()
	abiSellingMakeHeaders()
	abiAdjustingMakeHeaders()
	abiAdjustingMakeFrames()
	abiDeleteMakeHeaders()
	abiDeleteMakeFrames()
end



function abiTooltipSetItem(tooltip,...)

	if not abiTooltipAdded then
		abiAddTooltipData(tooltip,"None",0)
		abiTooltipAdded=true
	end

end



function abiTooltipCleared(tooltip,...)
	abiTooltipAdded=false
end



function abiAddTooltipData(tooltip,battlepetname,passed)

	local fn
	
	if GetMouseFocus()==nil then
		return
	end
		
	fn=GetMouseFocus():GetName()

	if fn==nil then
		return
	end

	if string.sub(fn,1,8)=="MailItem" then
		return
	end
	
	local abiRat1,abiRat2
	local abimultiplier=1
	local abiItemLink
	local abiBday,abiSday
	local t1,t2,RH,RL
	local abiFullCurrent
	
	abiStackSize=abiPresets[abiWhichPreset][24]

	if abiStackSize==nil or abiStackSize==0 then
		abiStackSize=1
	end

	if abiPriceIndex[abiRealm]==nil then
		abiPriceIndex[abiRealm]={}
	end --just making sure

	if battlepetname=="None" then
		abiImageName,_=tooltip:GetItem()
	else
		abiImageName=battlepetname
	end

-- Changes made below to make sure the bought/sold etc prices are from the full price history records, and not (if selected) the current prices.
-- The actual price history will still be from the current prices (if selected)

--	if abiCurrent==0 then

		if abiPriceIndex[abiRealm][abiImageName]~=nil then
			abiItemLink,abiBhigh1,abiBlow1,abiShigh1,abiSlow1,abiRsold1,abiRbought1,abiRatio1,abiSeen1,abiTimeStamp,abiRecentHigh,abiRecentLow,abiPriceHistory=abiDecodeIndex(abiPriceIndex[abiRealm][abiImageName])
		else
			tooltip:AddLine("Item not in main Abigail database")
			return
		end
--	end

	if abiCurrent==1 then

		if abiCurrentAuctions[abiImageName]~=nil then
			--abiItemLink,abiBhigh1,abiBlow1,abiShigh1,abiSlow1,abiRsold1,abiRbought1,abiRatio1,abiSeen1,_,abiRecentHigh,abiRecentLow,abiPriceHistory=abiDecodeIndex(abiCurrentAuctions[abiImageName])

			abiItemLink,_,_,_,_,_,_,_,_,_,_,_,abiPriceHistory=abiDecodeIndex(abiCurrentAuctions[abiImageName])



--		else
--			tooltip:AddLine("Item not in current Abigail database")
--			return
		end
	end

	abiRsold1,abiSday=abiDecodePriceDays(abiRsold1)
	abiRbought1,abiBday=abiDecodePriceDays(abiRbought1)
	t1,t2=strsplit(":",abiSeen1)
	t1=tonumber(t1)
	t2=tonumber(t2)
	RH,_=strsplit(":",abiRecentHigh)
	RL,_=strsplit(":",abiRecentLow)
	RH=tonumber(RH)
	RL=tonumber(RL)

	if IsShiftKeyDown()==true then
		abiBhigh1=abiBhigh1*abiStackSize
		abiBlow1=abiBlow1*abiStackSize
		abiShigh1=abiShigh1*abiStackSize
		abiSlow1=abiSlow1*abiStackSize
		abiRsold1=abiRsold1*abiStackSize
		abiRbought1=abiRbought1*abiStackSize
		abimultiplier=abiStackSize
		RH=RH*abiStackSize
		RL=RL*abiStackSize
	end

	if abimultiplier==1 then
		tooltip:AddLine("Abigail Pricing",0.5,0.5,1)
	else
		tooltip:AddLine("Abigail Pricing ("..abimultiplier..")",0.5,0.5,1)
	end

	if abiPresets[abiWhichPreset][7]==true then

		if abiBhigh1>0 then
			tooltip:AddDoubleLine("Buy-Hi :",abiCreatePriceStringIcons(abiBhigh1,""),1,1,1,1,1,1)
		else
			tooltip:AddDoubleLine("Buy-Hi :","-------------- ",1,1,1,1,1,1)
		end

		if abiBlow1>0 then
			tooltip:AddDoubleLine("Buy-Lo :",abiCreatePriceStringIcons(abiBlow1,""),1,1,1,1,1,1)
		else
			tooltip:AddDoubleLine("Buy-Lo :","-------------- ",1,1,1,1,1,1)
		end

	end

	if abiPresets[abiWhichPreset][9]==true then

		if abiShigh1>0 then
			tooltip:AddDoubleLine("Sold-Hi :",abiCreatePriceStringIcons(abiShigh1,""),1,1,1,1,1,1)
		else
			tooltip:AddDoubleLine("Sold-Hi :","-------------- ",1,1,1,1,1,1)
		end

		if abiSlow1>0 then
			tooltip:AddDoubleLine("Sold-Lo :",abiCreatePriceStringIcons(abiSlow1,""),1,1,1,1,1,1)
		else
			tooltip:AddDoubleLine("Sold-Lo :","-------------- ",1,1,1,1,1,1)
		end

	end

	if abiPresets[abiWhichPreset][8]==true then

		if abiRsold1>0 then
			tooltip:AddDoubleLine("Recent-Sold : ["..abiSday.." days]",abiCreatePriceStringIcons(abiRsold1,""),1,1,1,1,1,1)
		else
			tooltip:AddDoubleLine("Recent-Sold :","-------------- ",1,1,1,1,1,1)
		end

		if abiRbought1>0 then
			tooltip:AddDoubleLine("Recent-Bought : ["..abiBday.." days]",abiCreatePriceStringIcons(abiRbought1,""),1,1,1,1,1,1)
		else
			tooltip:AddDoubleLine("Recent-Bought :","-------------- ",1,1,1,1,1,1)
		end
	end

	if abiPresets[abiWhichPreset][26]==true then

		if RH>0 then
			tooltip:AddDoubleLine("7-Day High : ",abiCreatePriceStringIcons(RH,""),1,1,1,1,1,1)
		else
			tooltip:AddDoubleLine("7-Day High : ","-------------- ",1,1,1,1,1,1)
		end

		if RL>0 then
			tooltip:AddDoubleLine("7-Day Low : ",abiCreatePriceStringIcons(RL,""),1,1,1,1,1,1)
		else
			tooltip:AddDoubleLine("7-Day Low : ","-------------- ",1,1,1,1,1,1)
		end
	end

	if abiPresets[abiWhichPreset][10]==true then
		abiRat1,abiRat2=abiDecodeRatio(abiRatio1)
		tooltip:AddDoubleLine("Selling Ratio :",abiRat1.." sold from "..abiRat2.." auctions",1,1,1,1,1,1)
	end

	if abiPresets[abiWhichPreset][11]==true then
		abiDecodePriceHistory(abiPriceHistory)
		tooltip:AddDoubleLine("AH-Avg :",abiCreatePriceStringIcons(abiFindAveragePrice()*abimultiplier,""),1,1,1,1,1,1)
	end

		tooltip:AddDoubleLine("Times Seen :",t1.." : "..t2,1,1,1,1,1,1)

	if abiCurrent==0 then
		tooltip:AddDoubleLine("Last Seen :",abiGetNumDays(abiTimeStamp).." days",1,1,1,1,1,1)
	end

	if abiOnTheButton==1 or abiPresets[abiWhichPreset][12]==false or passed==1 then
		return
	end

	if abiCurrent==1 and abiCurrentAuctions[abiImageName]==nil then
		tooltip:AddLine("Item not in current Abigail database")
		return
	end


	if abiCurrent==0 then
		abiFullCurrent="Full Prices"
	else
		abiFullCurrent="Current Prices"
	end

	if abimultiplier==1 then
		tooltip:AddLine("Abigail Price History : "..abiFullCurrent,0.5,0.5,1)
	else
		tooltip:AddLine("Abigail Price History ("..abimultiplier..") : "..abiFullCurrent,0.5,0.5,1)
	end

	abiDecodePriceHistory(abiPriceHistory)
	local abiTotal=0
	local abiCount=0

	for abiloop=1,15 do

		if (abiHistorySeen[abiloop]~=nil) and (abiHistorySeen[abiloop]>0) then
			abiCount=abiCount+1
			abiTotal=abiTotal+abiHistorySeen[abiloop]
		end

	end

	if abiCount>0 then
		abiTotal=(abiTotal/abiCount)*1.5
	end

	for abiloop=1,15 do

		if (abiHistorySeen[abiloop]~=nil) and (abiHistorySeen[abiloop]>0) then

			if abiHistorySeen[abiloop]>=abiTotal and abiTotal>0 then
				tooltip:AddDoubleLine(abiHistorySeen[abiloop].." times at :",abiCreatePriceStringIcons(abiHistoryCost[abiloop]*abimultiplier,""),1,1,0,1,1,0)
			else
				tooltip:AddDoubleLine(abiHistorySeen[abiloop].." times at :",abiCreatePriceStringIcons(abiHistoryCost[abiloop]*abimultiplier,""),1,1,1,1,1,1)
			end

		end			

	end
	tooltip:Show()
end



function abiTooltipSelection()

	for abiloop=1,6 do
		abiPresets[abiWhichPreset][abiloop+6]=_G["abiTooltipCB"..abiloop]:GetChecked()
	end
	abiPresets[abiWhichPreset][26]=abiTooltipCB7:GetChecked()
end



function abiCreatePricingFrames()
-- check if the frames already made
	if (abiFS12) then
		return
	end

	local frameName1,frameName2,frameName3,frameName4

	for abiloop=1,13 do
		frameName1="abiFS"..abiloop.."2"
		frameName2="abiFS"..abiloop.."3"
		frameName3="abiFS"..abiloop.."4"
		frameName4="abiFS"..abiloop.."6"
		f=CreateFrame("Frame",frameName1,abiMessageFrame14,"AbigailMoneyFrameTemplate")
		f:SetPoint("TOPLEFT",abiMessageFrame14,"TOPLEFT",-15,22-(24*abiloop))
		f:Show()
		f=CreateFrame("Frame",frameName2,abiMessageFrame14,"AbigailMoneyFrameTemplate")
		f:SetPoint("TOPLEFT",abiMessageFrame14,"TOPLEFT",115,22-(24*abiloop))
		f:Show()
		f=CreateFrame("Frame",frameName3,abiMessageFrame14,"AbigailMoneyFrameTemplate")
		f:SetPoint("TOPLEFT",abiMessageFrame14,"TOPLEFT",245,22-(24*abiloop))
		f:Show()


		f=abiMessageFrame14:CreateFontString(frameName4)
		f:SetPoint("TOPLEFT",abiMessageFrame14,"TOPLEFT",260,24-(24*abiloop))
		f:SetFontObject(GameFontNormal)
		f:SetWidth(100)
		f:SetHeight(20)
		f:SetJustifyH("CENTER")
		f:SetText("")
		f:Hide()
	end
end



function abiCreatePriceHistoryFrames()
	local framename,checkname

	for abiPriceFrame=1,15 do

		framename="abiPS"..abiPriceFrame
		f=CreateFrame("Frame",framename,abiExtraFrame,"AbigailMoneyFrameTemplate")
		f:SetPoint("TOPLEFT",abiExtraFrame,"TOPLEFT",75,-5-(abiPriceFrame*20))

	end

	f=abiExtraFrame:CreateFontString("abiUPF11")
	f:SetPoint("TOPLEFT",abiExtraFrame,"TOPLEFT",75,-335)
	f:SetFontObject(GameFontNormal)
	f:SetWidth(100)
	f:SetHeight(20)
	f:SetJustifyH("CENTER")
	f:SetText("Price Per Unit")
	f:Hide()

	for abiUnitPriceFrame=2,5 do
		f=abiExtraFrame:CreateFontString("abiUPF1"..abiUnitPriceFrame)
		f:SetPoint("TOPLEFT",abiExtraFrame,"TOPLEFT",5,-320-(abiUnitPriceFrame*16))
		f:SetFontObject(GameFontNormal)
		f:SetWidth(65)
		f:SetHeight(20)
		f:SetJustifyH("RIGHT")
		f:SetText("")
		f:Hide()
	end
	
	for abiUnitPriceFrame=2,5 do
		framename="abiUPF2"..abiUnitPriceFrame
		f=CreateFrame("Frame",framename,abiExtraFrame,"AbigailMoneyFrameTemplate")
		f:SetPoint("TOPLEFT",abiExtraFrame,"TOPLEFT",85,-320-(abiUnitPriceFrame*16))
		f:Hide()
	end	

	for abiloop=1,5 do
		f=abiFiveBestFrame:CreateFontString("abiDisplayHeader"..abiloop)
		f:SetPoint("TOPLEFT",abiFiveBestFrame,"TOPLEFT",abiDHpos[abiloop],-25)
		f:SetFontObject(GameFontNormal)
		f:SetWidth(abiDHwide[abiloop])
		f:SetHeight(20)
		f:SetJustifyH("LEFT")
		f:SetText("|cffffffff"..abiDHtext[abiloop])
		f:Hide()
	end

	for abiloop=1,5 do

		f=abiFiveBestFrame:CreateFontString("abiDisplayDur"..abiloop)
		f:SetPoint("TOPLEFT",abiFiveBestFrame,"TOPLEFT",20,0-(30+(abiloop*20)))
		f:SetFontObject(GameFontNormal)
		f:SetWidth(60)
		f:SetHeight(20)
		f:SetJustifyH("LEFT")
		f:SetText(" ")
		f:Hide()

		f=abiFiveBestFrame:CreateFontString("abiDisplayName"..abiloop)
		f:SetPoint("TOPLEFT",abiFiveBestFrame,"TOPLEFT",50,0-(30+(abiloop*20)))
		f:SetFontObject(GameFontNormal)
		f:SetWidth(240)
		f:SetHeight(20)
		f:SetJustifyH("LEFT")
		f:SetText(" ")
		f:Hide()

		abiCreateBidBuyUnitFrame("abiDisplayBuy"..abiloop,300,abiloop)
		abiCreateBidBuyUnitFrame("abiDisplayBid"..abiloop,430,abiloop)
		abiCreateBidBuyUnitFrame("abiDisplayUnit"..abiloop,560,abiloop)
	end

	abiCreateProfitFrames("abiMoneySpentFrame",90)
	abiCreateProfitFrames("abiMoneyEarnedFrame",325)
	abiCreateProfitFrames("abiMoneyProfitFrame",550)
end


function abiCreateBidBuyUnitFrame(fn,posn,abiloop)
	f=CreateFrame("Frame",fn,abiFiveBestFrame,"AbigailMoneyFrameTemplate")
	f:SetPoint("TOPLEFT",abiFiveBestFrame,"TOPLEFT",posn,0-(30+(abiloop*20)))
	f:Hide()
end


function abiCreateProfitFrames(fn,posn)
	f=CreateFrame("Frame",fn,abiProfitLossFrame,"AbigailProfitFrameTemplate")
	f:SetPoint("TOPLEFT",abiProfitLossFrame,"TOPLEFT",posn,-7)
end



function abiSortByBuyout()

	if abiLastSearch=="Undercuts" then
		return
	end

	-- Could be a bid sort
	abiHowSorted=1-abiHowSorted
	local abiImageNumber

	for loop=1,#abiBargains do
		_,abiImageNumber=strsplit("%",abiBargains[loop])
		abiImageNumber=tonumber(abiImageNumber)
		_,abiImageCount,abiImagePrice,_,_,abiImageBid=abiDecodeImage(abiAHImage[abiImageNumber])

		if abiLastSearch=="Bargains" or abiLastSearch=="Shopping" or abiLastSearch=="My Profits" or abiLastSearch=="Single Items" then
			if abiStackUnitPrices==1 then
				abiBargains[loop]=abiMakeFullPrice(math.floor(abiImagePrice/abiImageCount)).."%"..tostring(abiImageNumber)
			else
				abiBargains[loop]=abiMakeFullPrice(abiImagePrice).."%"..tostring(abiImageNumber)
			end
		else
			if abiStackUnitPrices==1 then
				abiBargains[loop]=abiMakeFullPrice(math.floor(abiImageBid/abiImageCount)).."%"..tostring(abiImageNumber)
			else
				abiBargains[loop]=abiMakeFullPrice(abiImageBid).."%"..tostring(abiImageNumber)
			end
		end

	end

	if abiHowSorted==1 then
		table.sort(abiBargains,abiHighLow)
	else
		table.sort(abiBargains,abiLowHigh)
	end

	abiScrollFrame1:SetVerticalScroll(0)
	abiTableOffset=0
	abiDisplayTheItems()
end



function abiSortByProfit()

	if abiLastSearch=="Undercuts" then
		return
	end

	abiHowSorted=1-abiHowSorted
	local abiImageNumber
	local abiMySoldLow
	abiRealm=GetRealmName()..abiMyFaction

	for loop=1,#abiBargains do
		abiMoneyValue,abiImageNumber=strsplit("%",abiBargains[loop])
		abiImageNumber=tonumber(abiImageNumber)
		abiImageName,abiImageCount,abiImagePrice,_,_,abiImageBid=abiDecodeImage(abiAHImage[abiImageNumber])

		if abiCurrent==0 then
			_,_,_,_,abiMySoldLow,_,_,_,_,_,_,_,abiPriceHistory=abiDecodeIndex(abiPriceIndex[abiRealm][abiImageName])
		else
			_,_,_,_,abiMySoldLow,_,_,_,_,_,_,_,abiPriceHistory=abiDecodeIndex(abiCurrentAuctions[abiImageName])
		end

		abiMySoldLow=tonumber(abiMySoldLow)

		abiDecodePriceHistory(abiPriceHistory)
		abiItemAverage=abiFindAveragePrice()

		abiImagePrice=math.floor(abiImagePrice/abiImageCount) -- per unit price
		abiImageBid=math.floor(abiImageBid/abiImageCount) -- per unit price


		if abiLastSearch=="Bargains" or abiLastSearch=="Shopping"  or abiLastSearch=="My Profits" or abiLastSearch=="Single Items" then
			abiTemporaryNumber=abiItemAverage/abiImagePrice
			if abiLastSearch=="My Profits" then
				abiTemporaryNumber=abiMySoldLow/abiImagePrice
			end
		else

			if abiLastByBuyout~=1 then
				abiTemporaryNumber=(abiItemAverage-abiImageBid)/abiImageBid
			else
				abiTemporaryNumber=(abiImagePrice-abiImageBid)/abiImageBid
			end

		end                 

		abiTemporaryNumber=math.floor(abiTemporaryNumber*100)

		if abiSortingByPercent==0 then

			if abiLastSearch=="Bargains" or abiLastSearch=="Shopping" or abiLastSearch=="My Profits" or abiLastSearch=="Single Items" then
				if abiStackUnitPrices==0 then
abiBargains[loop]=abiMakeFullPrice((abiItemAverage-abiImagePrice)*abiImageCount).."%"..tostring(abiImageNumber)

					if abiLastSearch=="My Profits" then
						abiBargains[loop]=abiMakeFullPrice((abiMySoldLow-abiImagePrice)*abiImageCount).."%"..tostring(abiImageNumber)
					end

				else
					abiBargains[loop]=abiMakeFullPrice(abiItemAverage-abiImagePrice).."%"..tostring(abiImageNumber)

					if abiLastSearch=="My Profits" then
						abiBargains[loop]=abiMakeFullPrice(abiMySoldLow-abiImagePrice).."%"..tostring(abiImageNumber)
					end
				end
			else

				if abiLastByBuyout~=1 then
					if abiStackUnitPrices==0 then
						abiBargains[loop]=abiMakeFullPrice((abiItemAverage-abiImageBid)*abiImageCount).."%"..tostring(abiImageNumber)

					else
						abiBargains[loop]=abiMakeFullPrice(abiItemAverage-abiImageBid).."%"..tostring(abiImageNumber)

					end

				else
					if abiStackUnitPrices==0 then
							abiBargains[loop]=abiMakeFullPrice((abiImagePrice-abiImageBid)*abiImageCount).."%"..tostring(abiImageNumber)

					else
						abiBargains[loop]=abiMakeFullPrice(abiImagePrice-abiImageBid).."%"..tostring(abiImageNumber)
					end

				end

			end

		else
			abiBargains[loop]=abiMakeFullPrice(abiTemporaryNumber).."%"..tostring(abiImageNumber)
		end

	end

	if abiHowSorted==0 then
		table.sort(abiBargains,abiHighLow)
	else
		table.sort(abiBargains,abiLowHigh)
	end

	abiScrollFrame1:SetVerticalScroll(0)
	abiTableOffset=0
	abiDisplayTheItems()
end



function abiSortByPercent()
	abiSortingByPercent=1
	abiSortByProfit()
	abiSortingByPercent=0
end



function abiBidBuyoutButton_OnClick()

	if abiBidTime>4 then
		abiBidBuyoutButton:SetChecked(false)
		return
	end

end



function abiSelectCurrentMainButton_OnClick()
	abiCurrent=1-abiCurrent
	local extratext=" - Full Pricing Data"

	if abiCurrent==1 then
		extratext=" - Current Pricing Data"
	end
	
	if abiTesting==0 then
		abiOptionsHeader:SetText("Abigail 2.40 - Options Screen"..extratext)
	else
		abiOptionsHeader:SetText("Abigail 2.40 - Options Screen"..extratext.." (TESTING)")
	end

	abiBargainsHeader:SetText("Abigail 2.40 - Bargain Search Results"..extratext)
	abiShoppingHeader:SetText("Abigail 2.40 - Shopping Screen")
	abiSellingHeader:SetText("Abigail 2.40 - Selling Screen"..extratext)

	if abiCurrent==1 then
		abiCurrentMainButton:SetText("Current Prices")
		abiExtraTitle:SetText("|cffffffffCurrent Prices")
	else
		abiCurrentMainButton:SetText("Full Price History")
		abiExtraTitle:SetText("|cffffffffHistory Prices")
	end
end



function abiSelectWhichBidToUseButton_OnClick()
	abiBidTime=abiBidTime+1

	if abiBidTime==9 then
		abiBidTime=1
	end

	abiSelectWhichBidToUseButton:SetText(abiBidTimeTable[abiBidTime])

	if abiBidTime==5 then

		abiBargainSearchButton:SetText("Find Undercuts")

		abiBargainSearchButton.tooltipText="|cffffff00Search your auctions for any that|nare being undercut.|nTakes 10-30 seconds."
		abiBidBuyoutButton:Disable()
		abiBidBuyoutButton:SetChecked(false)
		return
	end

	if abiBidTime==8 then
		abiBargainSearchButton:SetText("Search Bargains")
	end

	if abiBidTime==7 then
		abiBargainSearchButton:SetText("Single Search")
	end

	if abiBidTime==6 then
		abiBargainSearchButton:SetText("Find My Profits")
	end

	if abiBidTime<6 then
		abiBargainSearchButton:SetText("Search Bids")
		abiBidBuyoutButton:Enable()
	end

	abiBargainSearchButton.tooltipText="|cffffff00Search the snapshot for bargains/bids."

end



function abiSelectScanTypeButton_OnClick()
	abiScanType=abiScanType+1
	if abiScanType==4 then
		abiScanType=1
	end
	abiSelectScanTypeButton:SetText(abiScanTypeText[abiScanType])
	abiCanTakeSnapShot=0
end



function abiOptionsFrameHelp(passed)
	abiOptionsHelpFrame:SetText("|cffffffff"..abiOptionsHelpText[passed])
end



function abiBargainsFrameHelp(passed)

	if passed==1 and abiLastSearchText=="Undercuts" then
		passed=2
	end

	abiBargainsHelpFrame:SetText("|cffffffff"..abiBargainsHelpText[passed])
end



function abiShowingFiveButton_OnClick()
	abiShowingFive=3-abiShowingFive

	if abiShowingFive==1 then
		abiShowingFiveButton:SetText("Show Best 5 : Off")
	else
		abiShowingFiveButton:SetText("Show Best 5 : On")
	end

end


function abiSelfClean()
	local t1,t2,t3,t4,t5,t6,t7,t8,t9,abiTimeStamp,t10,t11,t12
	local tempremoved=0
	local tempconsolodated=0
	local tempseenfixed=0
	local temprecovered=0
	local abiHalfIt=0
	local s1,s2
	local RH,RL,HT,LT
	local abiVendorPrice=0

	for k,v in pairs(abiPriceIndex) do
		-- k is realm

		for k2,v2 in pairs(abiPriceIndex[k]) do
			-- k2=namefield, v2=price index field
			t1,t2,t3,t4,t5,t6,t7,t8,t9,abiTimeStamp,t11,t12,_,t10=strsplit("%",v2)

			--t1 is itemlink
			-- t10 is pricehistory
			-- t11 is recent hight price
			-- t12 is recent low price

			if t10==nil or t10=="" then
				t10=recovermissingPH(k,k2,v2)
				temprecovered=temprecovered+1
			end

			-- Now, remove any temporary prices (0000000001*1) provided they are not the only price
			-- This now changed to remove temp prices that are <= item vendor price

			_,_,_,_,_,_,_,_,_,_,abiVendorPrice=GetItemInfo(t1)

			if abiVendorPrice==nil then
				abiVendorPrice=1
			end

			if abiVendorPrice==0 then
				abiVendorPrice=1
			end

			abiDecodePriceHistory(t10)

			if #abiHistoryCost>1 then

				for l=#abiHistoryCost,1,-1 do

					if abiHistoryCost[l]<=abiVendorPrice then
						table.remove(abiHistoryCost,l)
						table.remove(abiHistorySeen,l)
						tempremoved=tempremoved+1
					end

				end

			end

			s1,s2=strsplit(":",t9)

			if tonumber(s1)>tonumber(s2) then
				s1=s2
				tempseenfixed=tempseenfixed+1
			end

			if tonumber(s1)>9999999 then
				s1=9000000
				tempseenfixed=tempseenfixed+1
			end

			if tonumber(s2)>9999999 then
				s2=9000000
				tempseenfixed=tempseenfixed+1
			end

			t9=s1..":"..s2

			-- Now Consolodate The Prices

			abiHalfIt=0

			for l=1,#abiHistoryCost do

				if abiHistorySeen[l]>8000 then
					abiHalfIt=1
				end

			end


			if abiHalfIt==1 then

				for l=1,#abiHistoryCost do
					abiHistorySeen[l]=math.floor(abiHistorySeen[l]/2)

					if abiHistorySeen[l]<1 then
						abiHistorySeen[l]=1
					end

				end

			tempconsolodated=tempconsolodated+1

			end


			-- Now put the prices back into the PriceHistory record
			if abiTimeStamp=="x" then
				abiTimeStamp=time()
			end
			if t11=="x" then
				t11="0:0"
			end
			if t12=="x" then
				t12="0:0"
			end

			RH,HT=strsplit(":",t11)
			RL,LT=strsplit(":",t12)
			HT=tonumber(HT)
			LT=tonumber(LT)
			if time()-HT>604800 then
				t11="0:0"
			end
			if time()-LT>604800 then
				t12="0:0"
			end

			t10=abiEncodePriceHistory()
			abiPriceIndex[k][k2]=t1.."%"..t2.."%"..t3.."%"..t4.."%"..t5.."%"..t6.."%"..t7.."%"..t8.."%"..t9.."%"..abiTimeStamp.."%"..t11.."%"..t12.."%x%"..t10

		end
	end
        
	if tempremoved>0 then
		print("A total of "..tempremoved.." temporary pricing records have been found and removed")
	end

	if tempseenfixed>0 then
		print("A total of "..tempseenfixed.." times-seen records have been adjusted")
	end

	if temprecovered>0 then
		print("A total of "..temprecovered.." lost price-history records have been recovered")
	end

	if tempconsolodated>0 then
		print("A total of "..tempconsolodated.." pricing records have been consolodated")
	end

	-- now check if the Shopping list is in the old format - and change it if needed

	if abiPresets[1][32]~="2.40" then
		print("Updating the Shopping List format")
		abiPresets[1][32]="2.40"
		abiPresets[2][32]="2.40"
		abiPresets[3][32]="2.40"
		abiPresets[4][32]="2.40"
		abiPresets[5][32]="2.40"
		abiPresets[6][32]="2.40"

		for abiloop=1,6 do
			if abiPresets[abiloop][30]==6 then
				abiPresets[abiloop][30]=7
			end
		end

		local k,v,k2,v2,cost,percent

		local tempList={}
		for k,v in pairs(abiShoppingList) do
		-- k is realm with faction

			for k2,v2 in pairs(abiShoppingList[k]) do
				-- k2=namefield, v2=price index field
				cost,percent=strsplit("%",v2)

				if tempList[k]==nil then
					tempList[k]={}
				end

				tempList[k][k2]=cost.."%50"
			end

		end
		table.wipe(abiShoppingList)
		abiShoppingList=tempList
		print("Shopping List format updated")
		print("All files now updated to version 2.40")
	end

	-- Now remove any items from the Shopping List if that item is no longer in the Price Index file
	local abiTempShopList={}
	local abiShopRemoved=0
	for k,v in pairs(abiShoppingList) do
		for k2,v2 in pairs(abiShoppingList[k]) do
			if abiPriceIndex[k][k2]~=nil then
				if abiTempShopList[k]==nil then
					abiTempShopList[k]={}
				end
				abiTempShopList[k][k2]=v2
			else
				abiShopRemoved=abiShopRemoved+1
			end
		end
	end
	abiShoppingList=abiTempShopList
	if abiShopRemoved>0 then
		print(abiShopRemoved.." invalid shopping list entries removed.")
	end
end



function abiStackUnitButton_OnClick()
	abiStackUnitPrices=1-abiStackUnitPrices

	if abiStackUnitPrices==1 then
		abiStackUnitButton:SetText("Prices Per Unit")
	else
		abiStackUnitButton:SetText("Prices Per Stack")
	end

	abiDisplayTheItems()
end


function recovermissingPH(realm,itemname,pricedata)
	local t1,t2,t3,t4,t5,t6,t7,t8,t9,abiTimeStamp,_,_,_,t10=strsplit("%",pricedata)
	local n2,n3,n4,n5
	--abiLink1,abiBhigh1,abiBlow1,abiShigh1,abiSlow1,abiRsold1,abiRbought1,abiRatio1,abiSeen1,Time,abiPriceHistory
	local temp=0
	local vendor
	n2=tonumber(t2)
	n3=tonumber(t3)
	n4=tonumber(t4)
	n5=tonumber(t5)

	if n2>0 and temp==0 then
		temp=n2
	end

	if n3>0 and temp==0 then
		temp=n3
	end

	if n4>0 and temp==0 then
		temp=n4
	end

	if n5>0 and temp==0 then
		temp=n5
	end

	if temp==0 then	
		_,_,_,_,_,_,_,_,_,_,vendor=GetItemInfo(t1)
		if vendor==nil then
			vendor=0
		end

		if vendor==0 then
			vendor=1
		end

		temp=vendor
	end

	t10=abiMakeFullPrice(temp).."*1"
	print("Recovered price for : "..itemname)
	return t10
end



function abiShowProfitLossFrames()
	local t1=abiPLV[abiRealm][1] or 0
	local t2=abiPLV[abiRealm][2] or 0
	local t3=t1-t2
	AbigailMoneyFrame_Update("abiMoneyEarnedFrame",t1,"Earned","|cffffffff")
	AbigailMoneyFrame_Update("abiMoneySpentFrame",t2,"Spent","|cffffffff")

	if t3>=0 then
		AbigailMoneyFrame_Update("abiMoneyProfitFrame",t3,"Profit","|cffffffff")
	else
		AbigailMoneyFrame_Update("abiMoneyProfitFrame",t2-t1,"Loss","|cffff4040")
	end

	abiProfitLossFrame:Show()
end



-------------------------------------
-- Functions for handling the presets
-------------------------------------

function abiPSButtonClicked(passed)
	abiPresets[passed][1]=abiPresets[abiWhichPreset][1]
	abiSaveCurrentSettings()
	abiWhichPreset=passed
	abiSetButtonTextColour(passed)
	abiSetSlidersAndBoxes()
end



function abiDisablePSButtons()
	for abiloop=1,6 do
		_G["abiPSButton"..abiloop]:Disable()
	end
end



function abiEnablePSButtons()
	for abiloop=1,6 do
		_G["abiPSButton"..abiloop]:Enable()
	end
end



function abiSetButtonTextColour(passed)

	for abiloop=1,6 do
		_G["abiPSButton"..abiloop]:SetText("|c80808080"..abiloop)
	end
		_G["abiPSButton"..passed]:SetText("|cffffffff"..passed)
end



function abiSliderChanged(passed)
	_G[passed.."Text"]:SetText(math.floor(_G[passed]:GetValue()))
end



function abiSetSlidersAndBoxes()

	local abiTemporaryNumber

	for abiLoop=1,27 do

		if abiPresets[abiWhichPreset][abiLoop]==nil then
			abiPresets[abiWhichPreset][abiLoop]=0
		end

	end

	MinSpendSlider:SetValue(abiPresets[abiWhichPreset][2])
	abiTemporaryNumber=math.floor(GetMoney()/10000)
	MaxSpendSlider:SetMinMaxValues(0,abiTemporaryNumber)

	if abiPresets[abiWhichPreset][3]>abiTemporaryNumber then
		abiPresets[abiWhichPreset][3]=abiTemporaryNumber
	end

	MaxSpendSlider:SetValue(abiPresets[abiWhichPreset][3])
	ProfitMarginSlider:SetValue(abiPresets[abiWhichPreset][4])
	CashProfitSlider:SetValue(abiPresets[abiWhichPreset][5])
	DeviationSlider:SetValue(abiPresets[abiWhichPreset][6])
	MaxSameSlider:SetValue(abiPresets[abiWhichPreset][25])

	--Setup the tooltip check buttons

	for abiLoop=1,6 do
		_G["abiTooltipCB"..abiLoop]:SetChecked(abiPresets[abiWhichPreset][abiLoop+6])
	end
	abiTooltipCB7:SetChecked(abiPresets[abiWhichPreset][26])
	abiAutoBagCheck:SetChecked(abiPresets[abiWhichPreset][27])
	--Setup item type check buttons

	for abiLoop=1,11 do
		_G["abiTypeCheck"..abiLoop]:SetChecked(abiPresets[abiWhichPreset][abiLoop+12])
	end

	abiPresetName:SetText(abiPresets[abiWhichPreset][28])
	abiScanType=abiPresets[abiWhichPreset][29]
	abiBidTime=abiPresets[abiWhichPreset][30]
	abiCurrent=1-abiPresets[abiWhichPreset][31]
	abiSelectCurrentMainButton_OnClick()
	abiSelectScanTypeButton:SetText(abiScanTypeText[abiScanType])
	abiBidTime=abiBidTime-1
	abiSelectWhichBidToUseButton_OnClick()
end



function abiSaveCurrentSettings()

	abiPresets[abiWhichPreset][2]=floor(MinSpendSlider:GetValue())
	abiPresets[abiWhichPreset][3]=floor(MaxSpendSlider:GetValue())
	abiPresets[abiWhichPreset][4]=floor(ProfitMarginSlider:GetValue())
	abiPresets[abiWhichPreset][5]=floor(CashProfitSlider:GetValue())
	abiPresets[abiWhichPreset][6]=floor(DeviationSlider:GetValue())
	abiPresets[abiWhichPreset][25]=floor(MaxSameSlider:GetValue())
	abiPresets[abiWhichPreset][28]=abiPresetName:GetText()

	if abiPresets[abiWhichPreset][28]=="" then
		abiPresets[abiWhichPreset][28]="Unused"
	end

	--Setup the tooltip check buttons

	for abiLoop=1,6 do
		abiPresets[abiWhichPreset][abiLoop+6]=_G["abiTooltipCB"..abiLoop]:GetChecked()
	end

	abiPresets[abiWhichPreset][26]=abiTooltipCB7:GetChecked()
	abiPresets[abiWhichPreset][27]=abiAutoBagCheck:GetChecked()

	--Setup item type check buttons
	for abiLoop=1,11 do
		abiPresets[abiWhichPreset][abiLoop+12]=_G["abiTypeCheck"..abiLoop]:GetChecked()
	end

	abiPresets[abiWhichPreset][29]=abiScanType
	abiPresets[abiWhichPreset][30]=abiBidTime
	abiPresets[abiWhichPreset][31]=abiCurrent

end






